#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e5+6;
const int mod=1e9+7;
const int SQ=333;
void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector<pair<pair<int,int>,int> >qr[SQ];
int ans[MAXN];
int ans_slow[MAXN];
struct node
{
    int par,sz;
};
int n,q;
int a[MAXN];
int where_next[MAXN];
struct dsu
{
    vector<pair<int,node> >rollbacks;
    node f[MAXN];
    int maxsz;
    void init()
    {
        for(int i=1;i<MAXN;++i)
        {
            f[i].sz=1;
            f[i].par=i;
        }
        maxsz=1;
        rollbacks.clear();
    }
    int get_root(int u,bool track)
    {
        if(f[u].par==u)return u;
        int t=get_root(f[u].par,track);
        if(track)
        {
            rollbacks.push_back({u,f[u]});
        }
        f[u].par=t;
        return t;
    }
    void join(int p,int q,bool track)
    {
        p=get_root(p,track);
        q=get_root(q,track);
        if(p==q)return;
        if(track)
        {
            rollbacks.push_back({p,f[p]});
            rollbacks.push_back({q,f[q]});
        }
        if(f[p].sz>f[q].sz)
        {
            f[q].par=p;
            f[p].sz+=f[q].sz;
            maxsz=max(maxsz,f[p].sz);
        }
        else
        {
            f[p].par=q;
            f[q].sz+=f[p].sz;
            maxsz=max(maxsz,f[q].sz);
        }
    }
    void rollback_all()
    {
        for(int i=rollbacks.size()-1;i>=0;--i)
        {
            f[rollbacks[i].first]=rollbacks[i].second;
        }
        rollbacks.clear();
    }
}ds;
void add_edge(int x,bool track)
{
    ds.join(x,x+1,track);
}
int query_l[MAXN],query_r[MAXN];
/*void solve_slow()
{
    vector<int>v;
    for(int i=0;i<q;++i)
    {
        int l=query_l[i],r=query_r[i];
        v.clear();
        for(int j=l;j<=r;++j)
        {
            v.push_back(a[j]);
        }
        sort(v.begin(),v.end());
        int cnt=1;
        int maxcnt=1;
        for(int j=1;j<v.size();++j)
        {
            if(v[j]==v[j-1]+1)++cnt;
            else cnt=1;
            maxcnt=max(maxcnt,cnt);
        }
        ans_slow[i]=maxcnt;
    }
}*/
int solve_slow(int l,int r)
{
    vector<int>v;
    for(int j=l;j<=r;++j)
    {
        add_edge(a[j],1);
    }
    int ret=ds.maxsz;
    ds.rollback_all();
    ds.maxsz=1;
    return ret-1;
}
int main()
{
    fastIO();
    cin>>n>>q;

    //n=10000;q=1000;

    for(int i=1;i<=n;++i)cin>>a[i];

    //for(int i=1;i<=n;i++)a[i]=i;
    //shuffle(a+1,a+n+1,mt);

    //for(int i=1;i<=n;i++)cout<<a[i]<<" ";
    //cout<<endl;
    ds.init();

    for(int i=0;i<q;++i)
    {
        int l,r;
        cin>>l>>r;

        //l=mt()%n+1;
        //r=mt()%n+1;


        //if(l>r)swap(l,r);

        //query_l[i]=l;
        //query_r[i]=r;

        //cout<<l<<" "<<r<<endl;

        if(r-l<=SQ)
        {
            ans[i]=solve_slow(l,r);
        }
        else
        {
            //cout<<"*\n";
            qr[l/SQ].push_back({{r,l},i});
        }
    }

    //cout<<"-----------\n";

    for(int i=0;i<SQ;++i)
    {
        if(qr[i].size()==0)continue;
        sort(qr[i].begin(),qr[i].end());
        ds.init();
        int t1=(i+1)*SQ;
        int cur_r=t1-1;
        for(int j=0;j<qr[i].size();++j)
        {
            while(cur_r<qr[i][j].first.first)
            {
                ++cur_r;
                //cout<<"add "<<cur_r<<endl;
                add_edge(a[cur_r],0);
            }
            int maxsz1=ds.maxsz;
            for(int l=t1-1;l>=qr[i][j].first.second;--l)
            {
                //cout<<"add "<<l<<endl;
                add_edge(a[l],1);
            }
            ans[qr[i][j].second]=ds.maxsz-1;
            ds.rollback_all();
            ds.maxsz=maxsz1;
        }
    }
    //solve_slow();
    for(int i=0;i<q;++i)
    {
        //if(ans[i]!=ans_slow[i])cout<<ans[i]<<" "<<ans_slow[i]<<endl;
        cout<<ans[i]<<"\n";
    }
return 0;
}
