#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

pair<double,ll> binbrute[4004000];
pair<double,ll> v[1000100];
ll wei[1000100];
ll n,k;

void buildbin(ll pos,ll l,ll r){
  if(l==r){
    binbrute[pos].first=(sqrt(wei[l]+1)-sqrt(wei[l]))/v[l].first;
    binbrute[pos].second=l;
    //cout<<pos<<" "<<l<<" "<<r<<" "<<binbrute[pos].first<<endl;
    return ;
    }

  ll mid=(l+r)/2;
  buildbin(pos*2,l,mid);
  buildbin(pos*2+1,mid+1,r);
  binbrute[pos]=max(binbrute[pos*2],binbrute[pos*2+1]);
  //cout<<pos<<" "<<l<<" "<<r<<" "<<binbrute[pos].first<<endl;
  return ;
  }

void addbrute(ll pos,ll l,ll r,ll id){
  if(l==r){
    ++wei[l];
    binbrute[pos].first=(sqrt(wei[l]+1)-sqrt(wei[l]))/v[l].first;
    binbrute[pos].second=l;
    return ;
    }

  ll mid=(l+r)/2;
  if(id<=mid)addbrute(pos*2,l,mid,id);
  else addbrute(pos*2+1,mid+1,r,id);
  binbrute[pos]=max(binbrute[pos*2],binbrute[pos*2+1]);
  return ;
  }

ll brute(ll lef){
  buildbin(1,1,n);

  pair<double,ll> now;
  while(lef--){
    now=binbrute[1];
    addbrute(1,1,n,now.second);
    }
  }

int main(){

ios_base::sync_with_stdio(false);
cin.tie(NULL);cout.tie(NULL);

cin>>n>>k;
for(ll i=1;i<=n;++i){
  cin>>v[i].first;
  v[i].second=i;
  }

sort(v+1,v+n+1);

brute(k);

for(ll i=1;i<=n;++i){
  cout<<wei[v[i].second]<<" ";
  }
cout<<endl;

return 0;
}
/*
10 10
1 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9

3 3
1.2 2.5 3.7
*/
