#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long mod=1050000011;
long long n, m;

long long sumsq(long long t)
{
    long long a=t, b=t+1, c=2*t+1;
    if(a%2==0) a/=2;
    else if(b%2==0) b/=2;
    else c/=2;
    if(a%3==0) a/=3;
    else if(b%3==0) b/=3;
    else c/=3;
    return ((a%mod*b)%mod*c)%mod;
}

long long pow(long long t, long long p)
{
    if(p==0) return 1;
    if(p&1) return pow(t, p-1)*t;
    long long k=pow(t, p/2);
    return k*k;
}

long long st[2][1000006];

long long findsqrt(long long m)
{
    long long a=0, b=1e9;
    while(b-a>1)
    {
        long long mid=(a+b)/2;
        if(mid*mid<=m) a=mid;
        else b=mid;
    }
    return a;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    if(n==1) {cout<<m%mod<<endl; return 0;}
    if(n==2)
    {
        long long t=findsqrt(m);
        cout<<(((((m+1)%mod)*t)%mod-sumsq(t))%mod+mod)%mod<<endl;
        return 0;
    }
    else
    {
        long long t=findsqrt(m);
        for(int i=1; i<=1000000; i++)
        {
            long long gr=i; gr*=i, gr*=i;
            if(gr>m) break;
            long long le=0, ri=1e9;
            while(ri-le>1)
            {
                long long mid=(le+ri)/2;
                if(mid*mid<gr) le=mid;
                else ri=mid;
            }
            gr=ri;
            st[0][i]=(((((m+1)%mod)*(t-gr+1))%mod - sumsq(t)+sumsq(gr-1))%mod+mod)%mod;
        }
        for(int i=4; i<=38 && i<=n; i++)
        {
            long long id=1;
            for(int j=1; j<=1000000; j++)
            {
                long long p=1, m2=m, fl=1;
                for(int k=0; k<i; k++)
                {
                    p*=j;
                    m2/=j;
                    if(!m2 || p>m) {fl=0; break;}
                }
                if(!fl) break;
                while(id<=m && st[0][id] && pow(id, i-1)<pow(j, i)) id++;
                for(int k=id; k<=1000000; k++)
                {
                    st[1][j]+=st[0][k];
                    if(st[1][j]>=mod) st[1][j]-=mod;
                    if(!st[0][k]) break;
                }
            }
            for(int j=1; j<=1000000; j++)
            {
                st[0][j]=st[1][j];
                if(!st[1][j])
                {
                    while(j<=1000000 && st[0][j+1]) {j++; st[0][j]=0;}
                    break;
                }
            }
            for(int j=1; j<=1000000; j++)
            {
                st[1][j]=0;
                if(!st[1][j+1]) break;
            }
        }
        long long sum=0;
        for(int j=1; j<=1000000; j++) {sum+=st[0][j]; if(sum>=mod) sum-=mod;}
        cout<<sum<<endl;
    }
    return 0;
}
