#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long mod=1050000011;
long long n, m;

long long sumsq(long long t)
{
    long long a=t, b=t+1, c=2*t+1;
    if(a%2==0) a/=2;
    else if(b%2==0) b/=2;
    else c/=2;
    if(a%3==0) a/=3;
    else if(b%3==0) b/=3;
    else c/=3;
    return (a*b)%mod*c;
}

long long pow(long long t, long long p)
{
    if(p==0) return 1;
    if(p&1)
    {
        long long t2=pow(t, p-1);
        if(1e18/t2<t+2) return 1e18+1;
        return t2*t;
    }
    long long k=pow(t, p/2);
    if(k>1e9) return 1e18+1;
    return k*k;
}

long long st[2][1000006];
long long pr[1000006];

long long findsqrt(long long m)
{
    long long a=0, b=1e9;
    while(b-a>1)
    {
        long long mid=(a+b)/2;
        if(mid*mid<=m) a=mid;
        else b=mid;
    }
    return a;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    if(n==1) {cout<<m%mod<<endl; return 0;}
    if(n==2)
    {
        long long t=findsqrt(m);
        cout<<(((((m+1)%mod)*t)%mod-sumsq(t))%mod+mod)%mod<<endl;
        return 0;
    }
    else
    {
        long long t=findsqrt(m), sm=(m+1)%mod, lpr=0;
        for(int i=1; i<=1000000; i++)
        {
            long long gr=i; gr*=i, gr*=i;
            if(gr>m) break;
            long long le=sqrt(gr);
            if(le*le<gr) le++;
            gr=le;
            st[0][i]=(sm*(t-gr+1) - sumsq(t)+sumsq(gr-1))%mod;
            if(st[0][i]<0) st[0][i]+=mod;
            pr[i]=(pr[i-1]+st[0][i])%mod;
            lpr=pr[i];
        }
        for(int i=4; i<=38 && i<=n; i++)
        {
            long long id=1;
            for(int j=1; j<=1000000; j++)
            {
                while(id<=m && st[0][id] && pow(id, i-1)<pow(j, i)) id++;
                if(!st[0][id]) break;
                st[1][j]=(st[1][j]+lpr-pr[id-1]+mod)%mod;
            }
            for(int j=1; j<=1000000; j++)
            {
                st[0][j]=st[1][j];
                pr[j]=(pr[j-1]+st[0][j])%mod;
                lpr=pr[j];
                if(!st[1][j])
                {
                    while(j<=1000000 && st[0][j+1]) {j++; st[0][j]=0;}
                    break;
                }
            }
            for(int j=1; j<=1000000; j++)
            {
                st[1][j]=0;
                if(!st[1][j+1]) break;
            }
        }
        long long sum=0;
        for(int j=1; j<=1000000; j++) {sum+=st[0][j]; if(sum>=mod) sum-=mod;}
        cout<<sum<<endl;
    }
    return 0;
}
