#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=2e5+5;
const int MAXQ=2e5+5;
const int block=300;

struct Qry
{
    int l,r,num;
};

int n,q;
int a[MAXN];
Qry qr[MAXQ];
int maxl[MAXN];
int par[MAXN];
int tree[4*MAXN];
int ans[MAXQ];

int get_par(int ind)
{
    while(maxl[ind+1]) ind=par[ind+1];
    return ind;
}

void update(int node,int l,int r,int pos,int val)
{
    if(l==r)
    {
        tree[node]=val;
        return;
    }
    int mid=(l+r)>>1;
    if(pos<=mid) update(2*node,l,mid,pos,val);
    else update(2*node+1,mid+1,r,pos,val);
    tree[node]=max(tree[2*node],tree[2*node+1]);
}

int query(int node,int l,int r,int ql,int qr)
{
    if(ql<=l && r<=qr) return tree[node];
    int mid=(l+r)>>1;
    int ret=0;
    if(ql<=mid) ret=max(ret,query(2*node,l,mid,ql,qr));
    if(mid<qr) ret=max(ret,query(2*node+1,mid+1,r,ql,qr));
    return ret;
}

bool cmp(Qry a,Qry b)
{
    if(a.l/block==b.l/block)
    {
        if((a.l/block)&1) return a.r>b.r;
        return a.r<b.r;
    }
    return (a.l/block)<(b.l/block);
}

void add(int ind)
{
    maxl[a[ind]]=maxl[a[ind]-1]+1;
    if(maxl[a[ind]+1])
    {
        par[a[ind]]=get_par(a[ind]+1);
        maxl[par[a[ind]]]+=maxl[a[ind]];
    }
    else par[a[ind]]=a[ind];
    update(1,1,n,par[a[ind]],maxl[par[a[ind]]]);
}

void rem(int ind)
{
    int pr=get_par(a[ind]);
    if(maxl[a[ind]-1])
    {
        maxl[a[ind]-1]=maxl[pr]-(pr-a[ind]+1);
        par[a[ind]-1]=a[ind]-1;
        update(1,1,n,a[ind]-1,maxl[a[ind]-1]);
    }
    if(maxl[a[ind]+1])
    {
        maxl[a[ind]+1]=1;
    }
    maxl[pr]=pr-a[ind];
    update(1,1,n,pr,maxl[pr]);
    maxl[a[ind]]=par[a[ind]]=0;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>q;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
}
for(int i=0;i<q;i++)
{
    cin>>qr[i].l>>qr[i].r;
    qr[i].num=i;
}
sort(qr,qr+q,cmp);

int l=1,r=0;///
for(int i=0;i<q;i++)
{
    while(r<qr[i].r)
    {
        r++;
        add(r);
    }
    while(r>qr[i].r)
    {
        rem(r);
        r--;
    }
    while(l>qr[i].l)
    {
        l--;
        add(l);
    }
    while(l<qr[i].l)
    {
        rem(l);
        l++;
    }
    ans[qr[i].num]=query(1,1,n,1,n);
}

for(int i=0;i<q;i++)
{
    cout<<ans[i]<<endl;
}

return 0;
}
/*
6 6
4 1 6 3 5 2
1 5
2 4
3 6
1 6
2 5
5 6
*/
