#pragma GCC optimize ("Ofast")
#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=1e6+5;

long long n,k;
int tree[4*MAXN];
double x[MAXN];
double cur[MAXN];
long long ans[MAXN];

long long nextY(double c,double x)
{
    double t=c/x;
    long long l=1,r=k; ///
    while(l<r)
    {
        long long mid=(l+r)>>1; ///
        if(sqrt(mid)-sqrt(mid-1)>t) l=mid+1;
        else r=mid;
    }
    return r;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>k;
for(int i=1;i<=n;i++)
{
    cin>>x[i];
    x[i]=(double) 1/x[i];
    cur[i]=x[i];
}

while(k>0)
{
    long long t=max((k+n-1)/n, nextY(cur[2],x[1]));
    ans[1]+=t;
    cur[1]=(sqrt(ans[1]+1)-sqrt(ans[1]))*x[1];
    k-=t;
    for(int i=2;i<=n;i++)
    {
        long long t1=nextY(cur[i-1],x[i]);
        long long t2=nextY(cur[i+1],x[i]);
        long long t=min(t1, max((k+n-i)/(n-i+1),t2));
        ans[i]+=t;
        cur[i]=(sqrt(ans[i]+1)-sqrt(ans[i]))*x[i];
        k-=t;
    }
}

for(int i=1;i<=n;i++)
{
    cout<<ans[i]<<" ";
}
cout<<endl;

return 0;
}
