#include<iostream>
#include<queue>
#include<tuple>
#include<math.h>
using namespace std;

const int MAXN=1e5;

int ans[MAXN];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;


    priority_queue<tuple<double, int, double, int> > q;
    for(int i=0; i<n; i++)
    {
        double x;
        cin >> x;

        q.push({1/x, 0, x, i});
        ans[i]=0;
    }

    while(k--)
    {
        double profit, x;
        int cnt, idx;

        tie(profit, cnt, x, idx)=q.top();
        q.pop();

        cnt++;
        ans[idx]=cnt;

        profit=((sqrt(cnt)-sqrt(cnt-1))*1e6)/(x*1e6);

        q.push({profit, cnt, x, idx});
    }

    for(int i=0; i<n; i++)
    {
        cout << ans[i] << " ";
    }

    return 0;
}
