#include<iostream>
#include<queue>
#include<tuple>
#include<math.h>
#include<algorithm>
using namespace std;

const int MAXN=1e6;

long double xs[MAXN];
int ans[MAXN];
tuple<double, int, int> tempAns[MAXN];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    priority_queue<tuple<long double, long long, long double, long long> > q;
    for(int i=0; i<n; i++)
    {
        long double x;
        cin >> x;

        q.push({1/x, 0, x, i});
        ans[i]=0;
        xs[i]=x;
    }

    while(k>0)
    {
        long double profit, x;
        long long cnt, idx;

        tie(profit, cnt, x, idx)=q.top();
        q.pop();

        long double profit2, x2;
        long long cnt2, idx2;

        tie(profit2, cnt2, x2, idx2)=q.top();

        while(k>0 && profit>=profit2)
        {
            k--;
            cnt++;
            ans[idx]=cnt;

            profit=(sqrt(cnt+1)-sqrt(cnt))/x;
        }

        q.push({profit, cnt, x, idx});
    }

    for(int i=0; i<n; i++)
    {
        cout << ans[i] << " ";
    }
    cout << "\n";

    /*for(int i=0; i<n; i++)
    {
        tempAns[i]={xs[i], ans[i], i};
    }

    sort(tempAns, tempAns+n);

    int temp=10;
    while(temp--)
    {
        for(int i=0; i<n-1; i++)
        {
            long long nn, cnt, idx;
            tie(nn, cnt, idx)=tempAns[i];

            long long nn2, cnt2, idx2;
            tie(nn2, cnt2, idx2)=tempAns[i+1];

            long double res1=sqrt(cnt)/xs[idx]+sqrt(cnt2)/xs[idx2];
            long double res2=sqrt(cnt-1)/xs[idx]+sqrt(cnt2+1)/xs[idx2];
            long double res3=sqrt(cnt+1)/xs[idx]+sqrt(cnt2-1)/xs[idx2];
            while(cnt!=0 && res2>res1)
            {
                cnt2++;
                cnt--;

                if(cnt==0)
                {
                    break;
                }

                res2=sqrt(cnt-1)/xs[idx]+sqrt(cnt2+1)/xs[idx2];
                res1=sqrt(cnt)/xs[idx]+sqrt(cnt2)/xs[idx2];
            }

            while(cnt2!=0 && res3>res1)
            {
                cnt2--;
                cnt++;

                if(cnt2==0)
                {
                    break;
                }

                res3=sqrt(cnt+1)/xs[idx]+sqrt(cnt2-1)/xs[idx2];
                res1=sqrt(cnt)/xs[idx]+sqrt(cnt2)/xs[idx2];
            }

            tempAns[i]={nn, cnt, idx};
            tempAns[i+1]={nn2, cnt2, idx2};
        }
    }

    for(int i=0; i<n; i++)
    {
        long long nn, cnt, idx;
        tie(nn, cnt, idx)=tempAns[i];

        ans[idx]=cnt;
    }

    for(int i=0; i<n; i++)
    {
        cout << ans[i] << " ";
    }*/

    return 0;
}
