#include <iostream>
#include <cmath>
#include <stack>
using namespace std;
const int MAXN=1e5+10;
const int MAXK=1e2+10;
double x[MAXN], sq[MAXN], dp[MAXN][MAXK];
int next_ind[MAXN][MAXK];
stack <int> st;
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    for (int i=0;i<n;i++) cin >> x[i];
    for (int i=0;i<=k;i++) sq[i]=sqrt((double)i);
    for (int i=0;i<=k;i++) {
        dp[0][i]=sq[i]/x[0];
        next_ind[0][i]=i;
    }
    for (int i=1;i<n;i++) {
        for (int j=0;j<=k;j++) {
            for (int p=0;p<=j;p++) {
                double cur=dp[i-1][j-p]+sq[p]/x[i];
                if (cur>dp[i][j]) {
                    dp[i][j]=cur;
                    next_ind[i][j]=p;
                }
            }
        }
    }
    int i=n-1, j=k;
    while (i>=0) {
        st.push(next_ind[i][j]);
        j-=next_ind[i][j];
        i--;
    }
    while (!st.empty()) {
        cout << st.top() << ' ';
        st.pop();
    }
    cout << endl;
    return 0;
}

