#include <iostream>
#include <unordered_map>
using namespace std;
const long long mod=1050000011;
long long m;
unordered_map <long long, long long> um;
long long check_pow(long long a, long long b, long long ch) {
    if (a==1 || b==0) {
        if (ch==0) return -1;
        return 1;
    }
    if (b%2==0) {
        long long s=check_pow(a,b/2,ch);
        if (s==-1 || ch/s<s) return -1;
        return s*s;
    }
    long long s=check_pow(a,b-1,ch);
    if (s==-1 || ch/s<a) return -1;
    return a*s;
}
long long power(long long a, long long b) {
    if (a==1) return 1;
    if (b==0) return 1;
    if (b%2==0) {
        long long s=power(a,b/2);
        return s*s;
    }
    return a*power(a,b-1);
}
long long f(long long a, long long b) {
    long long l, r, mid;
    l=1; r=m;
    while (l<=r) {
        mid=(l+r)/2;
        if (check_pow(mid,b,a-1)!=-1) l=mid+1;
        else r=mid-1;
    }
    return l;
}
long long val(long long a, long long b) {
    return a*mod+b;
}
long long solve(long long n, long long gr) {
    ///cout << n << ' ' << m << ' ' << gr << endl;
    if (n==1) return m-gr+1;
    long long curv=val(n,gr);
    if (um[curv]!=0) return um[curv];
    um[curv]=0;
    for (long long i=gr;i<=m && check_pow(i,n,m)!=-1;i++) um[curv]+=solve(n-1,f(power(i,n),n-1));
    return um[curv]=um[curv]%mod;
}
int main () {
    long long n;
    cin >> n >> m;
    cout << solve(n,1) << endl;
    return 0;
}
