#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll Size=5e4+1;
ll a[Size];
bitset<Size> seg_tree[6*Size];

void build(ll l,ll r,ll i){
    if(l==r){
        seg_tree[i].set(a[l],true);
    }else{
        ll mid=(l+r)/2;
        build(l,mid,i*2);
        build(mid+1,r,i*2+1);
        seg_tree[i]=seg_tree[i*2]|seg_tree[i*2+1];
    }
}

bitset<Size> query(ll l,ll r,ll tl,ll tr,ll i){
    if(tr<l or tl>r){
        bitset<Size> ans;
        return ans;
    }
    if(tl==l and tr==r){
        return seg_tree[i];
    }else{
        ll mid=(l+r)/2;
        bitset<Size> left=query(l,mid,tl,min(mid,tr),i*2);
        bitset<Size> right=query(mid+1,r,max(mid+1,tl),tr,i*2+1);
        return left|right;
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n,q;
    cin>>n>>q;
    for(ll i=0;i<n;i++){
        cin>>a[i];
    }
    build(0,n-1,1);
    for(ll i=0;i<q;i++){
        ll from,to;
        cin>>from>>to;
        from--; to--;
        bitset<Size> res=query(0,n-1,from,to,1);
        ll best_ans=0,curr_ans=0;
        for(ll j=res._Find_next(0);j<Size;j=res._Find_next(j)){
            for(;res.test(j);j++){
                curr_ans++;
            }
            best_ans=max(best_ans,curr_ans);
            curr_ans=0;
        }
        cout<<best_ans<<endl;
    }
    return 0;
}
