#include<iostream>
#include<vector>
#include<cmath>
using namespace std;

const int MAX_SIZE = 10e6;

double diff[MAX_SIZE];
double prod[MAX_SIZE];
int each[MAX_SIZE];

void distribute(int n) {
    double net = 0;
    int ind = 0;
    for (int i = 0; i < n; ++i) {
        double calc = sqrt(((double)(each[i] + 1))) / diff[i] - prod[i];
        if (calc > net) {
            net = calc;
            ind = i;
        }
    }

    prod[ind] = net;
    ++each[ind];
}


int main() {
    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; ++i) {
        cin >> diff[i];
        each[i] = 0;
        prod[i] = 0;
    }

    for (int i = 0; i < k; ++i) {
      distribute(n);
    }

    for (int i = 0; i < n; ++i) {
        cout << each[i] << " ";
    }

    return 0;
}
