#include<iostream>
#include<vector>
#include<cmath>
using namespace std;

const int MAX_SIZE = 10e6;

long double diff[MAX_SIZE];
long double prod[MAX_SIZE];
int each[MAX_SIZE];

void distribute(int n, int def) {
    long double net = 0;
    int ind = def;
    for (int i = 0; i < n; ++i) {
        long double calc = (sqrt((double)each[i] + 1) / diff[i]) - prod[i];
        if (calc > net) {
            net = calc;
            ind = i;
        }
    }

    prod[ind] = net;
    each[ind] += 1;
}


int main() {
    int n, k;
    cin >> n >> k;

    int smind = 0;
    for (int i = 0; i < n; ++i) {
        diff[i] = 0;
        cin >> diff[i];
        if (diff[i] < diff[smind])
            smind = i;
        each[i] = 0;
        prod[i] = 0;
    }

    for (int i = 0; i < k; ++i) {
      distribute(n, smind);
    }

    for (int i = 0; i < n; ++i) {
        cout << each[i] << " ";
    }

    return 0;
}
