#include <iostream>
#include <algorithm>
#include <vector>

#define endl '\n'

using namespace std;

const int MAXN = 2e5 + 3;

int nums[MAXN];

int calc_result(int l, int r, int n)
{
    vector<int> current;
    for (int i = l; i <= r; ++i)
    {
        current.push_back(nums[i]);
    }

    sort(current.begin(), current.end());

    int res = 0;
    int start_i = 0;

    for (int i = 0; i < r - l + 1; ++i)
    {
        if (i > 0 and current[i] > current[i - 1] + 1)
        {
            start_i = i;
        }

        res = max(res, i - start_i + 1);
    }

    return res;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; ++i)
    {
        cin >> nums[i];
    }

    for (int i = 0; i < q; ++i)
    {
        int l, r;
        cin >> l >> r;

        --l;
        --r;

        cout << calc_result(l, r, n) << endl;
    }

    return 0;
}
