#include <iostream>
#include <algorithm>
#include <vector>

#define endl '\n'

using namespace std;

const int MAXN = 2e5 + 3;

int nums[MAXN];
int counter[MAXN];

int calc_result(int l, int r, int n)
{
    for (int i = 0; i < n; ++i)
    {
        counter[i] = 0;
    }

    for (int i = l; i <= r; ++i)
    {
        ++counter[nums[i] - 1];
    }

    int res = 0;
    int start_i = 0;

    for (int i = 0; i < n; ++i)
    {
        if (counter[i] == 0)
        {
            start_i = -1;
            continue;
        }

        if (start_i == -1)
        {
            start_i = i;
        }

        res = max(res, i - start_i + 1);
    }

    return res;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; ++i)
    {
        cin >> nums[i];
    }

    for (int i = 0; i < q; ++i)
    {
        int l, r;
        cin >> l >> r;

        --l;
        --r;

        cout << calc_result(l, r, n) << endl;
    }

    return 0;
}
