#pragma GCC optimize ("O3")

#include <iostream>
#include <cstdint>
#include <queue>
#include <cmath>
#include <algorithm>

#define MAX_N 200005

uint64_t n;
uint64_t q;
uint64_t arr[MAX_N];
uint64_t aux[MAX_N];

void init() {}

uint64_t query(uint64_t l, uint64_t r) {
	l -= 1;
	
	for (uint64_t i = l; i < r; i += 1) {
		aux[i-l] = arr[i];
	}
	
	std::sort(aux, aux+r-l);
	
	uint64_t best = 1;
	uint64_t curr = 1;
	for (uint64_t i = 1; i < r - l; i += 1) {
		if (aux[i] == aux[i-1]+1) {
			curr += 1;
		} else {
			curr = 1;
		}
		
		if (curr > best) best = curr;
	}
	
	return best;
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	std::cin >> n >> q;
	for (uint64_t i = 0; i < n; i += 1) {
		std::cin >> arr[i];
	}
	
	init();
	
	for (uint64_t i = 0; i < q; i += 1) {
		uint64_t l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << std::endl;
	}
}