#pragma GCC optimize ("O3")

#include <iostream>
#include <cstdint>
#include <cmath>

#define MAX_N 1000006
#define MAX_K 1000000012

uint64_t n;
uint64_t k;
double   xs[MAX_N];
uint64_t ys[MAX_N];

void add_one_programmer() {
	double best_add = 0;
	uint64_t best_i = -1;
	
	for (uint64_t i = 0; i < n; i += 1) {
		double curr_add = (sqrt(ys[i]+1) - sqrt(ys[i])) / xs[i];
		if (curr_add > best_add) {
			best_add = curr_add;
			best_i = i;
		}
	}
	
	ys[best_i] += 1;
}

void print_ys(std::ostream &os) {
	for (uint64_t i = 0; i < n; i += 1) {
		os << ys[i] << " ";
	}
	os << std::endl;	
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	std::cin >> n >> k;
	for (uint64_t i = 0; i < n; i += 1) {
		std::cin >> xs[i];
	}
	
	for (uint64_t i = 0; i < k; i += 1) {
		add_one_programmer();
		//print_ys(std::cerr);
	}
	
	print_ys(std::cout);
}