#include<bits/stdc++.h>
using namespace std;

long long n,m;

const long long mod=1050000011;

long long root(long long x,long long y){
    return pow(x,1.0/y);
}

long long power(long long x,long long y){
    if(y==0)return 1;
    if(y==1)return x;
    if(y==2)return x*x;
    if(y%2==0)return power(power(x,y/2),2);
    return power(power(x,y/2),2)*x;
}

long long brute(int pos,long long last){
    if(pos==0)return 1;

    long long res=0;

    for(long long i=root(power(last,pos+1),pos);i<=root(m,pos);i++){
        if(power(i,pos)>m)break;
        res+=brute(pos-1,i);
        res%=mod;
    }

    return res;
}

int main(){


    cin>>n>>m;
    n=min(n,64LL);
    cout<<brute(n,1)<<"\n";

    return 0;
}

