#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast, unroll-loops")
// #pragma GCC target("avx2, tune=native")
#define endl "\n"

using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

typedef long long ll;
const ll mod = 1050000011;

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const ll MAX_N = 1e6 + 10;
ll n, m;

vector<pair<ll, ll> > digans[MAX_N];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    cin >> n >> m;
    if(n == 1) {
        cout << m % mod << endl;
        return 0;
    }

    ll now = 0;
    for(ll i = 1; i * i <= m; i ++) {
        now = (now + m - i * i + 1) % mod;
        digans[2].push_back({i * i, now});
    }

    ll last = -1;

    for(ll i = 3; i <= n; i ++) {
        ll now = 0;
        for(ll j = 1; true; j ++) {
            ll pw = 1;
            for(ll k = 0; k < i; k ++) { pw = (pw * j); }
            if(pw > m) { break; } // TODO: Fix

            auto it = lower_bound(digans[i - 1].begin(), digans[i - 1].end(), make_pair(pw, (ll)-1));
            if(it == digans[i - 1].begin()) {
                now = (now + digans[i - 1].back().second) % mod;
            } else {
                it --;
                now = now + digans[i - 1].back().second - (*it).second;
                now = (now % mod + mod) % mod;
            }
            digans[i].push_back({pw, now});
        }
        if((1ll << i) > m) {
            if(last != -1) {
                break;
            } else {
                last = i + 1;
            }
        }
    }
    if(last == -1 || last == n + 1) {
        last = n;
    }

    ll ret = digans[last].back().second;

    cout << ret << endl;

    return 0;
}

