#include <iostream>
#define MAX_N 20005
using namespace std;

int perm[MAX_N];
int graf[MAX_N];
int sizeComp[MAX_N];
int indexi[MAX_N];
int n, q;


int parent(int index)
{
    if(graf[index]==index)
    {
        return index;
    }
    return graf[index]=parent(graf[index]);
}

bool connected(int ind1, int ind2)
{
    return (parent(ind1)==parent(ind2));
}

void editcompsize(int parentin, int newValue)
{
    for(int i=1; i<=n; i++)
    {
        if(connected(parentin, i))
        {
            sizeComp[i]=newValue;
        }
    }
}

void connect(int ind1, int ind2, int &currmax)
{
    int h=sizeComp[ind1];
    if(!connected(ind1, ind2))
    {
        graf[parent(ind1)]=parent(ind2);
        sizeComp[ind1]=sizeComp[ind1]+sizeComp[ind2];
        sizeComp[ind2]=sizeComp[ind1];
        editcompsize(parent(ind2), sizeComp[ind2]);
        //cout << sizeComp[ind1] << " " << sizeComp[ind2] << endl;
        if(sizeComp[ind2]>currmax)
        {
            currmax=sizeComp[ind2];
        }
    }
}


int calcSeg(int l, int r)
{
    int currmax=1;
    fill_n(sizeComp, MAX_N, 0);
    for(int i=l; i<=r; i++)
    {
        graf[i]=i;
        sizeComp[i]=1;

        if(perm[i]+1<=n && indexi[perm[i]+1]<=r && indexi[perm[i]+1]>=l)
        {
            //cout << "###" << perm[i]<< endl;
            connect(i, indexi[perm[i]+1], currmax);
        }
        if(perm[i]-1>0 && indexi[perm[i]-1]<=r && indexi[perm[i]-1]>=l)
        {
            //cout << "***" <<perm[i] << endl;
            connect(i, indexi[perm[i]-1], currmax);
        }
        //cout << currmax << endl;
    }
    return currmax;
}


int main()
{
    cin >> n >> q;

    for(int i=1; i<=n; i++)
    {
        cin >> perm[i];
        indexi[perm[i]]=i;
    }

    int l, r;

    for(int i=0; i<q; i++)
    {
        cin >> l >> r;
        cout << calcSeg(l, r) << endl;
    }







    return 0;
}
