#include<bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("Ofast")
using namespace std;
const int maxn = 5e4+3;
const int crit = 250;
const int maxq = 2e5+3;
struct Query
{
    int l,r,ind;
};
bool fff(Query a,Query b)
{
    if(a.l/crit!=b.l/crit)
        return a.l/crit<b.l/crit;
    return a.r<b.r;
}
vector <Query> queries;
int i,j,p,q,n,m,k,Q,ch[maxn],ans[maxq];
struct ST
{
    int pref;///index of the other endpoint
    int suf;
    int mx;
    bool full;
}a[4*maxn];
ST Merge(ST a,ST b,int l,int r)
{
    ST ans;
    ans.mx = max(a.mx,b.mx);
    if(a.suf!=-1 && b.pref!=-1)
    {
        int br = b.pref-a.suf+1;
        ans.mx=max(ans.mx,br);
    }
    ans.full = 0;
    int mid = (l+r)/2;
    if(a.full && b.full)
        ans.full = 1;
    if(a.full)
        ans.pref = max(b.pref,mid);///ako b.pref = -1
    else ans.pref = a.pref;
    if(b.full)
    {
        if(a.suf==-1)
            ans.suf = mid+1;
        else ans.suf = a.suf;
    }
    else ans.suf = b.suf;

    if(ans.pref!=-1)
        ans.mx = max(ans.mx,ans.pref-l+1);
    if(ans.suf!=-1)
        ans.mx = max(ans.mx,r-ans.suf+1);
    return ans;
}


void update(int val,int idx,int p=1,int l=1,int r=n)
{
   // cout<<val<<" "<<idx<<endl;
    if(l==r)
    {
        if(val==-1)
        {
            a[p].mx = 0;
            a[p].pref = -1;
            a[p].suf = -1;
            a[p].full = 0;
        }
        else
        {
            a[p].mx = 1;
            a[p].pref = l;
            a[p].suf = l;
            a[p].full = 1;
        }
        return ;
    }
    int mid = (l+r)/2;
    if(idx<=mid)
        update(val,idx,p*2,l,mid);
    else update(val,idx,p*2+1,mid+1,r);
    a[p] = Merge(a[p*2],a[p*2+1],l,r);
   // cout<<"sled upd "<<p<<" "<<l<<" "<<r<<" "<<a[p].pref<<" "<<a[p].suf<<" "<<a[p].mx<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>Q;
    for(i=1;i<=n;i++)
    {
        cin>>ch[i];
    }
    for(i=1;i<=4*n;i++)
        a[i] = {-1,-1,0,0};
    for(i=1;i<=Q;i++)
    {
        cin>>p>>q;
        queries.push_back({p,q,i});
    }
    sort(queries.begin(),queries.end(),fff);

    int ll = 1, rr = 1;
    update(1,ch[1]);
    for(auto i:queries)
    {
        p = i.l;q = i.r;
       // cout<<"Mo "<<ll<<" "<<rr<<" "<<p<<" "<<q<<endl;
        while(rr<q)
        {
            rr++;
            update(1,ch[rr]);
        }
        while(rr>q)
        {
            update(-1,ch[rr]);
            rr--;
        }
        while(ll>p)
        {
            ll--;
            update(1,ch[ll]);
        }
        while(ll<p)
        {
            update(-1,ch[ll]);
            ll++;
        }
        ans[i.ind] = a[1].mx;
    }
    for(i=1;i<=Q;i++)
        cout<<ans[i]<<endl;
    return 0;
}
/**
4 2
2 4 1 3
1 4
2 4

6 5
1 3 6 2 4 5
1 4
1 6
2 4
3 5
2 6
*/
