#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int LOG = 20;

int a[MAXN + 5], pos[MAXN + 5];
int stmx[MAXN + 5][LOG + 5], stmn[MAXN + 5][LOG + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        pos[a[i]] = i;
    }
    a[n + 1] = pos[n + 1] = n + 1;

    for (int i = 1; i <= n; ++ i)
    {
        stmx[i][0] = stmn[i][0] = pos[i + 1];
    }

    for (int j = 1; j <= 2; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            if (a[stmx[i][j - 1]] > a[stmx[min(1ll * n, i + (1ll << (j - 1)))][j - 1]]) stmx[i][j] = stmx[i][j - 1];
            else stmx[i][j] = stmx[min(1ll * n, i + (1ll << (j - 1)))][j - 1];
            if (a[stmn[i][j - 1]] < a[stmn[min(1ll * n, i + (1ll << (j - 1)))][j - 1]]) stmn[i][j] = stmn[i][j - 1];
            else stmn[i][j] = stmn[min(1ll * n, i + (1ll << (j - 1)))][j - 1];
        }
    }

    for (int i = 1; i <= q; ++ i)
    {
        int l, r;
        cin >> l >> r;

        int lg = 0;
        while ((1ll << lg) <= r - l + 1) lg++;
        lg--;

        int ans = 0;
        for (int j = l; j <= r; ++ j)
        {
            int p = a[j];
            for (int k = lg; k >= 0; -- k)
            {
                if (stmx[p][k] <= r and stmn[p][k] >= l) p += (1ll << k);
            }
            ans = max(ans, p - a[j] + 1);
        }
        cout << ans << endl;
    }

    return 0;
}
