#include <iostream>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXK = 100;

int ans[MAXN + 5];
double x[MAXN + 5];
int opt[MAXN + 5][MAXK + 5];
double dp[MAXN + 5][MAXK + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    long long k;
    cin >> n >> k;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> x[i];
    }

    for (int j = 0; j <= k; ++ j)
    {
        dp[1][j] = (double)(sqrt(1.0 * j) / x[1]);
        opt[1][j] = j;
    }

    for (int i = 2; i <= n; ++ i)
    {
        for (int j = 0; j <= k; ++ j)
        {
            for (int t = 0; t <= j; ++ t)
            {
                if (dp[i][j] < dp[i - 1][t] + (double)(sqrt(1.0 * (j - t)) / x[i]))
                {
                    dp[i][j] = dp[i - 1][t] + (double)(sqrt(1.0 * (j - t)) / x[i]);
                    opt[i][j] = j - t;
                }
            }
        }
    }

    for (int i = n; i >= 1; -- i)
    {
        ans[i] = opt[i][k];
        k -= opt[i][k];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cout << ans[i] << " ";
    }
    cout << endl;

    return 0;
}
