#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e2 + 10;

int n;
ll k;
pair < double, ll > x[maxn];
double work[maxn];
int cur[maxn], best[maxn];
double best_cost;

void brute(int idx, ll left, double sum)
{
    if (idx == n + 1)
    {
        if (best_cost < sum)
        {
            best_cost = sum;
            for (int i = 1; i <= n; i ++)
                best[i] = cur[i];
        }
        return;
    }

    for (ll p = 0; p <= left; p ++)
    {
        double new_sum = sum + (double)(sqrt)(p) / x[idx].first;
        cur[idx] = p;
        brute(idx + 1, left - p, new_sum);
        cur[idx] = 0;
    }
}

void solve()
{
    cin >> n >> k;
    for (int i = 1; i <= n; i ++)
    {
        cin >> x[i].first;
        x[i].second = i;
    }

    brute(1, k, 0);

    for (int i = 1; i <= n; i ++)
        cout << best[i] << " ";
    cout << endl;
}

int main()
{
    solve();
    return 0;
}
/**
3 10
3.7 1.2 2.5
*/
