#include<bits/stdc++.h>
#pragma GCC optimize ("O3, unroll-loops")
using namespace std;

const int maxn = 1024;
const long long mod = 1050000011;
int n, m;
long long dp[maxn][maxn];

long long st(long long a, int s)
{
    if (s == 0) return 1;
    if (s == 1) return a;
    long long k = st(a, s/2);
    if (s&1) return (((k*k)%mod)*a)%mod;
    return ((k*k)%mod);
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, j, k;
    for (j=m; j>0; --j)
        dp[1][j] = 1;
    for (i=2; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            for (k=m; k>0; --k)
            {
                if (st(k,i-1) >= st(j,i))
                {
                    //cout<< j << " comes after " << k << '\n' ;
                    dp[i][j] += dp[i-1][k];
                    dp[i][j] %= mod;
                }
                else
                    break;
            }
        }
    }

    long long ans = 0;
    for (j=1; j<=m; ++j)
    {
        ans += dp[n][j];
        ans %= mod;
    }
    cout << ans << '\n' ;
}

int main()
{
    solve();
    return 0;
}