#include<bits/stdc++.h>
using namespace std;
long long const maxk = 1e12;
int const maxn =  1e6 + 10;
int n;
long long k;
double x[maxn], ans;
long long taskworkers[maxn];
double get_gain(int task, long long addw){
    return (double) sqrt((double)(taskworkers[task] + addw)) / x[task] -
           (double) sqrt((double)(taskworkers[task])) / x[task];
}
long long bs(int task, double othergain){
    long long l = 0;/// the rightest num which give us a better gain > othergain
    long long r = k + (long long)1; ///the leftest num which do not give us a better gain > othergain
    long long mid;
    double gain;
    while (l + 1 < r){
        //mid = l + (r - l) / 2;
        mid = (l + r) / 2;
        gain = get_gain(task, mid);
        //cout << "mid == " << mid << " gain == " << gain << endl;
        if (gain > othergain)
            l = mid;
        else r = mid;
    }
    return l;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> k;
    priority_queue< pair<double, int> > q;
    for (int i = 1; i <= n; ++i){
        cin >> x[i];
        q.push({(double)1/x[i], i});
    }
    while (k){
        pair<double, int> cur = q.top();
        q.pop();
        pair<double, int> nexttop = q.top();
        /*ans += cur.first;
        taskworkers[cur.second]++;
        double diff = (double) sqrt((double)(taskworkers[cur.second] + 1)) / x[cur.second] -
                      (double) sqrt((double)(taskworkers[cur.second])) / x[cur.second];
        q.push({diff, cur.second});*/
        ans += cur.first;
        taskworkers[cur.second]++;
        k--;
        long long times = bs(cur.second, nexttop.first);
        //cout << "times == " << times << endl;
        ans += get_gain(cur.second, times);
        taskworkers[cur.second] += times;
        k -= times;
        double pushgain = get_gain(cur.second, 1);
        q.push({pushgain, cur.second});
    }
    for (int i = 1; i <= n; ++i)
        cout << taskworkers[i] << " ";
    cout << "\n";
	return 0;
}
