#include<iostream>
#define endl "\n"
using namespace std;

long long const MAXN=500010, mod = 1050000011;
long long n, m, pw[MAXN], dp[MAXN], par_sum[MAXN];

long long bin_search(long long l, long long r, long long x)
{
    while(l <= r)
    {
        long long mid = (l+r)/2;
        if(pw[mid] >= x) r = mid-1;
        else l = mid+1;
    }
    return l;
}

void read()
{
    long long ans = 0;
    cin>>n>>m;
    for(long long i=1;i<=m;i++)
    {
        dp[i] = 1;
        pw[i] = i;
        par_sum[i] = par_sum[i-1] + 1;
    }
    long long f = m;
    for(long long i=2;i<=n;i++)
    {
        for(long long j=1;j<=f;j++)
        {
            if(pw[j]*j > m)
            {
                f = j-1;
                break;
            }
            long long last = bin_search(1,f,pw[j]*j);
            dp[pw[j]*j] = (((par_sum[f] - par_sum[last-1])%mod+mod)%mod);
            dp[pw[j]*j] %= mod;
        }
        for(long long j=1;j<=f;j++)
        {
            pw[j] *= j;
            par_sum[j] = par_sum[j-1]+dp[pw[j]];
            par_sum[j] %= mod;
        }
    }
    for(long long i=1;i<=f;i++)
    {
        ans += dp[i];
    }
    cout<<ans%mod<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
