#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 5e5 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, q;
int a[MAXN];
int place[MAXN];
void read()
{
    cin >> n >> q;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        place[a[i]] = i;
    }
}
int x[MAXN * 4], y[MAXN * 4];

void build_tree(int i, int l, int r)
{
    if(l == r)
    {
        x[i] = place[l];
        y[i] = place[l];
        return;
    }
    int mid = (l + r)/2;
    build_tree(2*i, l, mid);
    build_tree(2*i+1, mid+1, r);
    x[i] = min(x[2*i], x[2*i+1]);
    y[i] = max(y[2*i], y[2*i+1]);
}
int ql, qr;
pair < int, int > query(int i, int l, int r)
{
    if(l == r)
    {
        return make_pair(x[i], y[i]);
    }
    if(ql > r || qr < l)return make_pair(-1, -1);
    if(ql <= l && r <= qr)return make_pair(x[i], y[i]);
    int mid = (l + r)/2;
    pair < int, int > first_half = query(2*i, l, mid);
    pair < int, int > second_half = query(2*i+1, mid + 1, r);
    if(first_half.first == -1 && first_half.second == -1)return second_half;
    if(second_half.first == -1 && second_half.second == -1)return first_half;
    return make_pair(min(first_half.first, second_half.first), max(first_half.second, second_half.second));
}
int ll, rr;

bool check(int x)
{
    for (int i = 1; i <= n-x+1; ++ i)
    {
        ql = i;
        qr = i+x-1;
        pair < int, int > segm = query(1, 1, n);
        //cout << segm.first << " " << segm.second << endl;
        if(segm.first < ll || segm.second > rr)continue;
        return true;
    }
    return false;
}
void solve()
{
    while(q --)
    {
        cin >> ll >> rr;
        int l = 1, r = n, mid = 0, ans = 1; /// binary search za distance-a
        while(l <= r)
        {
            mid = (l + r)/2;
            if(check(mid))
            {
                ans = mid;
                l = mid + 1;
            }
            else r = mid - 1;
        }
        cout << ans << endl;
    }
}
int main()
{
    speed();

    read();
    build_tree(1, 1, n);
    solve();
    return 0;
}
