#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 1e3 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m;
long long st[MAXN/**chislo*/][MAXN/**stepen*/];

void build_st()
{
    for (long long i = 1; i <= m; ++ i)
    {
        st[i][0] = 1;
        for (long long j = 1; j <= n; ++ j)
        {
            st[i][j] = st[i][j-1] * i;
        }
    }
}
int predi[MAXN/**stepen*/][MAXN/**chislo*/];
void precompute()
{
    for (int i = 2; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            long long x = st[j][i];
            int l = 1, r = m, ans = m+1, mid;
            while(l <= r)
            {
                mid = (l + r)/2;
                if(st[mid][i-1] >= x)
                {
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }
            predi[i][j] = ans;
        }
    }
}
long long dp[MAXN/**stepen*/][MAXN/***chislo*/];
long long mod = 1050000011;
void solve()
{
    for (int i =1; i <= m; ++ i)
    {
        dp[1][i] = 1;
    }
    long long ans = 0;
    for (int i = 2; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            int pr = predi[i][j];
            for (int k = pr; k <= m; ++ k)
            {
                dp[i][j] += dp[i-1][k];
                dp[i][j] %= mod;
            }
           // cout << i << " " << j << " " << dp[i][j] << endl;
            if(i == n)
        {
            ans += dp[i][j];

            ans %= mod;
        }
        }

    }
    cout << ans << endl;
}
int main()
{
    speed();

    cin >> n >> m;

    build_st();
    precompute();
    solve();
    return 0;
}
