#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 1e3 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m;
string st[MAXN/**chislo*/][MAXN/**stepen*/];

string make_string(long long x)
{
    string s = "";
    while(x)
    {
        s = (char)(x%10 + '0') + s;
        x /= 10;
    }
    return s;
}
void make_equal(string&a, string&b)
{
    int sza = a.size(), szb = b.size();
    if(sza == szb)return;
    if(sza < szb)
    {
        for (int i = sza+1; i <= szb; ++ i)
        {
            a = "0" + a;
        }
    }
    else
    {
        for (int i = szb+1; i <= sza; ++ i)
        {
            b = "0" + b;
        }
    }
}
string add(string a, string b)
{
    make_equal(a, b);
    //cout << a << " " << b << endl;
    int n, p = 0;
    string ans = "";
    for(int i = a.size()-1; i>=0; -- i)
    {
        n = (int)(a[i] - '0') + (int)(b[i] - '0') + p;
        p = n/10;
        n %= 10;
        ans = (char)(n + '0') + ans;
    }
    if(p)ans = (char)(p + '0') + ans;
    //cout << ans << endl;
    return ans;
}
string mult_digit(string a, int d)
{
    int n, p = 0;
    string ans = "";
    for(int i = a.size()-1; i>=0; -- i)
    {
        n = (int)(a[i] - '0')*d + p;
        p = n/10;
        n %= 10;
        ans = (char)(n + '0') + ans;
    }
    if(p)ans = (char)(p + '0') + ans;
    return ans;
}
string mult(string a, string b)
{
    string g[10];
    g[0] = "0";
    g[1] = a;
    for (int i = 2; i <= 9; ++ i)
        g[i] = mult_digit(a, i);
    string ans = "";
    string nuli = "", toadd;
    for (int i = b.size()-1;  i >= 0; -- i)
    {
        int cif = (int)(b[i] - '0');
        toadd = g[cif];
        toadd = toadd + nuli;
        ans = add(ans, toadd);
        nuli += "0";
    }
    return ans;
}
void build_st()
{
    for (long long i = 1; i <= m; ++ i)
    {
        st[i][0] = "1";
        for (long long j = 1; j <= n; ++ j)
        {
            st[i][j] = mult(st[i][j-1], make_string(i));
            //cout << i << " " << j << " " << st[i][j] << endl;
        }
    }
}
bool cmp(string a, string b)
{
    string aa = "";
    string bb = "";
    int i = 0;
    while(i < a.size() && a[i] == '0')i ++;
    for (int j = i; j < a.size(); ++ j)
        aa = aa + a[i];
    i = 0;
    while(i < b.size() && b[i] == '0')i ++;
    for (int j = i; j < b.size(); ++ j)
        bb = bb + b[i];
    if(aa.size() != bb.size())return (aa.size() > bb.size());
    for (int i = 0; i < aa.size(); ++ i)
    {
        if(aa[i] != bb[i])
        {
            return (aa[i] > bb[i]);
        }
    }
    return true;
}
int predi[MAXN/**stepen*/][MAXN/**chislo*/];
void precompute()
{
    for (int i = 2; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            string x = st[j][i];

            int l = 1, r = m, ans = m+1, mid;
            while(l <= r)
            {
                mid = (l + r)/2;
                if(cmp(st[mid][i-1], x))
                {
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }
            predi[i][j] = ans;
        }
    }
}
long long dp[MAXN/**stepen*/][MAXN/***chislo*/];
long long p[MAXN][MAXN];
long long mod = 1050000011;
void solve()
{
    for (int i =1; i <= m; ++ i)
    {
        dp[1][i] = 1;
        p[1][i] = i;
    }
    long long ans = 0;
    for (int i = 2; i <= n; ++ i)
    {

        for (int j = 1; j <= m; ++ j)
        {
            int pr = predi[i][j];
            if(pr == m+1)dp[i][j] = 0;
            else
            {
                long long sum = p[i-1][m] - p[i-1][pr-1];
            if(sum < 1LL * 0)sum += mod;
            dp[i][j] = sum;
            }

           // cout << i << " " << j << " " << dp[i][j] << endl;
            if(i == n)
        {
            ans += dp[i][j];

            ans %= mod;
        }
        p[i][j] = p[i][j-1] + dp[i][j];
        p[i][j] %= mod;
        }

    }
    if(n == 1)cout << m << endl;
    else cout << ans << endl;
}
int main()
{
    speed();

    cin >> n >> m;

    build_st();
    precompute();
    solve();
    return 0;
}
