#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
using namespace std;
const int MAXN=2e5+6;
const int mod=1e9+7;
const int SQ=450;
void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector<pair<pair<int,int>,int> >qr[SQ];
int ans[MAXN];
int ans_slow[MAXN];
int n,q;
int a[MAXN];
int where_next[MAXN];
struct dsu
{
    vector<pair<int,pair<pair<int,int>,bool> > >rollbacks;
    pair<pair<int,int>,bool> f[MAXN];
    int maxsz;
    void init()
    {
        for(int i=1;i<MAXN;++i)
        {
            f[i].first.first=i;
            f[i].first.second=i;
            f[i].second=0;
        }
        maxsz=1;
        rollbacks.clear();
    }
    void add(int x,bool track)
    {
        if(f[x-1].second&&!f[x+1].second)
        {
            int l1=f[x-1].first.first;
            int r1=f[x-1].first.second;
            if(track)rollbacks.push_back({l1,f[l1]});
            if(track)rollbacks.push_back({r1,f[r1]});
            if(track)rollbacks.push_back({x,f[x]});
            f[l1].first.second=x;
            f[x].first.first=l1;
            f[x].first.second=x;
            f[x].second=1;
            //cout<<"new "<<f[x].first.first<<" "<<f[x].first.second<<endl;
            maxsz=max(maxsz,f[x].first.second-f[x].first.first+1);
        }
        else if(!f[x-1].second&&f[x+1].second)
        {
            int l1=f[x+1].first.first;
            int r1=f[x+1].first.second;
            if(track)rollbacks.push_back({l1,f[l1]});
            if(track)rollbacks.push_back({r1,f[r1]});
            if(track)rollbacks.push_back({x,f[x]});
            f[r1].first.first=x;
            f[x].first.first=x;
            f[x].first.second=r1;
            f[x].second=1;
            //cout<<"new "<<f[x].first.first<<" "<<f[x].first.second<<endl;
            maxsz=max(maxsz,f[x].first.second-f[x].first.first+1);
        }
        else if(!f[x-1].second&&!f[x+1].second)
        {
            if(track)rollbacks.push_back({x,f[x]});
            f[x].first.first=x;
            f[x].first.second=x;
            f[x].second=1;
            //cout<<"new "<<f[x].first.first<<" "<<f[x].first.second<<endl;
            maxsz=max(maxsz,f[x].first.second-f[x].first.first+1);
        }
        else
        {
            int l1=f[x-1].first.first;
            int r1=f[x-1].first.second;
            int l2=f[x+1].first.first;
            int r2=f[x+1].first.second;
            if(track)rollbacks.push_back({l1,f[l1]});
            if(track)rollbacks.push_back({l2,f[l2]});
            if(track)rollbacks.push_back({r1,f[r1]});
            if(track)rollbacks.push_back({r2,f[r2]});
            if(track)rollbacks.push_back({x,f[x]});
            f[x].second=1;
            f[r2].first.first=l1;
            f[l1].first.second=r2;
            //cout<<"new "<<l1<<" "<<r2<<endl;
            maxsz=max(maxsz,r2-l1+1);
        }
    }
    void rollback_all()
    {
        for(int i=rollbacks.size()-1;i>=0;--i)
        {
            f[rollbacks[i].first]=rollbacks[i].second;
        }
        rollbacks.clear();
    }
}ds;
void add_edge(int x,bool track)
{
    ds.add(x,track);
}
int query_l[MAXN],query_r[MAXN];
void solve_slow()
{
    vector<int>v;
    for(int i=0;i<q;++i)
    {
        int l=query_l[i],r=query_r[i];
        v.clear();
        for(int j=l;j<=r;++j)
        {
            v.push_back(a[j]);
        }
        sort(v.begin(),v.end());
        int cnt=1;
        int maxcnt=1;
        for(int j=1;j<v.size();++j)
        {
            if(v[j]==v[j-1]+1)++cnt;
            else cnt=1;
            maxcnt=max(maxcnt,cnt);
        }
        ans_slow[i]=maxcnt;
    }
}
int solve_slow(int l,int r)
{
    vector<int>v;
    for(int j=l;j<=r;++j)
    {
        //cout<<"add "<<a[j]<<endl;
        add_edge(a[j],1);
    }
    int ret=ds.maxsz;
    ds.rollback_all();
    ds.maxsz=1;
    return ret;
}
mt19937 mt(4545);
int main()
{
    fastIO();
    cin>>n>>q;

    //n=5000;q=5000;

    for(int i=1;i<=n;++i)cin>>a[i];

    //for(int i=1;i<=n;i++)a[i]=i;
    //shuffle(a+1,a+n+1,mt);

    //for(int i=1;i<=n;i++)cout<<a[i]<<" ";
    //cout<<endl;
    ds.init();

    for(int i=0;i<q;++i)
    {
        int l,r;
        cin>>l>>r;

        //l=mt()%n+1;
        //r=mt()%n+1;


        //if(l>r)swap(l,r);

        //query_l[i]=l;
        //query_r[i]=r;

        //cout<<l<<" "<<r<<endl;

        if(r-l<=SQ)
        {
            ans[i]=solve_slow(l,r);
        }
        else
        {
            //cout<<"*\n";
            qr[l/SQ].push_back({{r,l},i});
        }
    }

    //cout<<"-----------\n";

    for(int i=0;i<SQ;++i)
    {
        if(qr[i].size()==0)continue;
        sort(qr[i].begin(),qr[i].end());
        ds.init();
        int t1=(i+1)*SQ;
        int cur_r=t1-1;
        for(int j=0;j<qr[i].size();++j)
        {
            while(cur_r<qr[i][j].first.first)
            {
                ++cur_r;
                //cout<<"add "<<cur_r<<endl;
                add_edge(a[cur_r],0);
            }
            int maxsz1=ds.maxsz;
            for(int l=t1-1;l>=qr[i][j].first.second;--l)
            {
                //cout<<"add "<<l<<endl;
                add_edge(a[l],1);
            }
            ans[qr[i][j].second]=ds.maxsz;
            ds.rollback_all();
            ds.maxsz=maxsz1;
        }
    }
    //solve_slow();
    for(int i=0;i<q;++i)
    {
        //if(ans[i]!=ans_slow[i])cout<<i<<" " <<ans[i]<<" "<<ans_slow[i]<<endl;
        cout<<ans[i]<<"\n";
    }
return 0;
}
