#include<bits/stdc++.h>
using namespace std;
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#define ll long long
const ll MAXN=1e6+2;
const ll mod=1050000011;
const ll fr=1e9;
void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
ll n,m;
ll fastpow(ll x,ll p)
{
    if(p==0)return 1ll;
    if(p==1)return x;
    ll t=fastpow(x,p/2ll);
    if(t>fr)return 0ll;
    t*=t;
    if(t==0)return 0ll;
    if(p%2ll==1ll)
    {
        if(x>m/t)
        {
            return 0ll;
        }
        t*=x;
    }
    return t;
}
ll fastpow_mod(ll x,ll p)
{
    if(p==0ll)return 1ll;
    if(p==1ll)return x;
    ll t=fastpow_mod(x,p/2ll);
    //if(t>fr)return 0;
    t*=t;t%=mod;
    if(p%2ll==1ll)
    {
        t*=x;
        t%=mod;
    }
    return t;
}
ll dp[2][MAXN];
ll maxv[MAXN];
ll val[MAXN];
ll prefsum[MAXN];
ll mul(ll x,ll y)
{
    if(x>mod)x=x%mod;
    if(y>mod)y=y%mod;
    return (x*y)%mod;
}
ll add(ll x,ll y)
{
    if(x>mod)x=x%mod;
    if(y>mod)y=y%mod;
    return (x+y)%mod;
}
ll sub(ll x,ll y)
{
    if(x>mod)x=x%mod;
    if(y>mod)y=y%mod;
    return (x-y+mod)%mod;
}
ll divide(ll x,ll y)
{
    if(x>mod)x=x%mod;
    if(y>mod)y=y%mod;
    return (x*fastpow_mod(y,mod-2ll))%mod;
}
ll r2,r6;
ll get_sum(ll x)
{
    return mul(mul(x,(x+1ll)),r2);
}
ll get_sum2(ll x)
{
    return mul(mul(mul(x,(2ll*x+1ll)),(x+1ll)),r6);
}
ll pwm=-1;
ll last_calc=-1,pwx;
ll pref_what(ll x)
{
    if(x==m&&pwm!=-1)return pwm;
    if(x==0)return 0ll;
    if(x==1)return 1ll;
    ll ret=0;
    ll sq=sqrt(x);
    if(sq==1)return x;
    sq--;
    ret+=mul(2ll,get_sum2(sq));
    //cout<<"1* "<<ret<<endl;
    ret%=mod;
    ret+=get_sum(sq);
    //cout<<"2* "<<ret<<endl;
    ret%=mod;
    ret+=mul(sub(x+1ll,mul((sq+1ll),(sq+1ll))),(sq+1ll));
    ret%=mod;
    //cout<<"3* "<<ret<<endl;
    //cout<<x<<" "<<ret<<endl;
    return ret;
}
ll get_what(ll x)
{
    if(x==0ll)return 0ll;
    /*if(x!=last_calc)
    {
        pwx=pref_what(x-1ll);
        last_calc=x;
    }*/
    ll cnt1=sub(pwm,pref_what(x-1ll));
    //cout<<cnt1<<endl;
    ll cnt2=mul(sqrt(x),(m-x+1ll));
    //cout<<cnt2<<endl;
    ll cnt3=sub(m+1ll,x);
    //cout<<cnt3<<endl;
    cnt1=(cnt1-cnt2+cnt3+mod)%mod;
    return cnt1;
}
ll get_up_sq(ll x)
{
    ll y=sqrt(x);
    if(y*y==x)return y;
    else return y+1ll;
}
int main()
{
    r2=fastpow_mod(2,mod-2);
    r6=fastpow_mod(6,mod-2);
    cin>>n>>m;
    if(n==1)
    {
        cout<<m%mod<<endl;
        return 0;
    }
    pwm=pref_what(m);
    if(n==2)
    {
        cout<<get_what(1)<<endl;
        return 0;
    }
    //only 59 elements
    int len=min(n,59ll);
    for(int i=1;i<=len;++i)
    {
        //cout<<"&& "<<i<<endl;
        //cout<<i<<endl;
        if(i==1ll)
        {
            maxv[i]=m;
        }
        else if(i==2ll)
        {
            maxv[i]=sqrt(m);
        }
        else
        {

            for(ll j=1ll;;++j)
            {
                //cout<<j<<endl;
                ll pow1=fastpow(j,i);
                //cout<<pow1<<endl;
                if(pow1<=m&&pow1!=0)
                {
                    maxv[i]=j;
                }
                else break;
            }
        }
    }
    //cout<<"?1\n";
    /*for(ll i=1;i<=sqrt(m);i++)
    {
        val[i]=m-i*i+1;
    }*/
    for(int i=1;i<=maxv[len];++i)
    {
        dp[len%2][i]=1;
        prefsum[i]=(prefsum[i-1]+dp[len%2][i])%mod;
    }
    for(int i=len-1;i>=3;--i)
    {
        //cout<<"& "<<i<<endl;
        for(ll j=1;j<=maxv[i];++j)dp[i%2][j]=0;
        ll ptr=maxv[i+1];
        for(ll j=maxv[i];j>=1;--j)
        {
            //cout<<"* "<<fastpow(j,i)<<endl;
            while(fastpow(ptr,i+1)>fastpow(j,i))
            {
                ptr--;
            }
            //cout<<i<<" "<<j<<" "<<prefsum[ptr]<<" "<<ptr<<endl;
            dp[i%2][j]=prefsum[min(maxv[i+1],ptr)];
        }
        for(ll j=1;j<=maxv[i];++j)
        {
            prefsum[j]=add(prefsum[j-1],dp[i%2][j]);
        }
    }
    ll ans=0;
    //cout<<"hey\n";
    for(ll i=1;i<=maxv[3];++i)
    {
        //cout<<i<<" "<<val[i]<<" "<<dp[i][2%2]<<endl;
        ll cnt2=get_what(get_up_sq(i*i*i)*get_up_sq(i*i*i));
        //cout<<i<<" "<<cnt2<<" "<<dp[i][1]<<endl;
        ans+=(dp[1][i]*cnt2)%mod;ans%=mod;
    }
    cout<<ans<<"\n";
return 0;
}
