#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct query
{
    int le, ri, ans, nom;
    query() {}
    query(int a, int b) {le=a; ri=b;}
};

bool operator<(query p, query q)
{
    if(p.le/200==q.le/200) return p.ri<q.ri;
    return p.le<q.le;
}

bool cmp(query p, query q)
{
    return p.nom<q.nom;
}

set<pair<int, int> > st;
multiset<int> sz;

int n, q;
int a[200005];
query qu[200005];

void rm(int val)
{
    set<pair<int, int> >::iterator it=st.lower_bound({val, val});
    it--;
    int tr=(*it).first, tl=(*it).second;
    sz.erase(sz.find(tr-tl+1));
    st.erase(it);
    if(tr!=val)
    {
    sz.insert(tr-val);
    st.insert({tr, val+1});
    }
    if(val!=tl)
    {
    sz.insert(val-tl);
    st.insert({val-1, tl});
    }
}

void ad(int val)
{
    int rl=val, rr=val;
    set<pair<int, int> >::iterator it=st.lower_bound({val, val});
    if(it!=st.end() && (*it).second==val+1)
    {
        rr=(*it).first;
        sz.erase(sz.find(rr-val));
        st.erase(it);
    }
    it=st.lower_bound({val, val});
    if(it!=st.begin())
    {
        it--;
        if((*it).first==val-1)
        {
            rl=(*it).second;
            sz.erase(sz.find(val-rl));
            st.erase(it);
        }
    }
    st.insert({rr, rl});
    sz.insert(rr-rl+1);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1; i<=n; i++) cin>>a[i];
    for(int i=0; i<q; i++)
    {
        cin>>qu[i].le>>qu[i].ri;
        qu[i].nom=i;
    }
    sort(qu, qu+q);
    st.insert({a[1], a[1]});
    sz.insert(1);
    int tle=1, tri=1;
    for(int i=0; i<q; i++)
    {
        int nle=qu[i].le, nri=qu[i].ri;
        while(tle<nle) {rm(a[tle]); tle++;}
        while(tle>nle) {ad(a[tle-1]); tle--;}
        while(tri>nri) {rm(a[tri]); tri--;}
        while(tri<nri) {ad(a[tri+1]); tri++;}
        multiset<int>:: iterator it=sz.end();
        it--;
        qu[i].ans=(*it);
    }
    sort(qu, qu+q, cmp);
    for(int i=0; i<q; i++) cout<<qu[i].ans<<endl;
    return 0;
}

