#pragma GCC optimize("Ofast")
#pragma GCC target ("sse4")
#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=2e5+5;
const int MAXQ=2e5+5;
const int block=500;

struct Qry
{
    int l,r,num;
};

int n,q;
int a[MAXN];
Qry qr[MAXQ];
int ans[MAXQ];
map<int,int> len;
set<pair<int,int> > rng;

bool cmp(Qry a,Qry b)
{
    if(a.l/block==b.l/block)
    {
        if((a.l/block)&1) return a.r>b.r;
        return a.r<b.r;
    }
    return (a.l/block)<(b.l/block);
}

void ins(int val)
{
    int t=len[val];
    t++;
    len[val]=t;
}

void ers(int val)
{
    int t=len[val];
    t--;
    if(t==0) len.erase(val);
    else len[val]=t;
}

void add(int x)
{
    auto it=rng.upper_bound({x,0});
    auto it1=it;
    it1--;
    int l1=(*it1).first, r1=(*it1).second;
    int l2=(*it).first, r2=(*it).second;
    if(r1==x-1 && x+1==l2)
    {
        rng.erase(it);
        rng.erase(it1);
        ers(r1-l1+1);
        ers(r2-l2+1);
        rng.insert({l1,r2});
        ins(r2-l1+1);
        return;
    }
    if(r1==x-1)
    {
        rng.erase(it1);
        ers(r1-l1+1);
        rng.insert({l1,x});
        ins(x-l1+1);
        return;
    }
    if(x+1==l2)
    {
        rng.erase(it);
        ers(r2-l2+1);
        rng.insert({x,r2});
        ins(r2-x+1);
        return;
    }
    rng.insert({x,x});
    ins(1);
    return;
}

void rem(int x)
{
    auto it=rng.upper_bound({x,1e9});
    it--;
    int l=(*it).first;
    int r=(*it).second;
    rng.erase(it);
    ers(r-l+1);
    if(l<x)
    {
        rng.insert({l,x-1});
        ins(x-l);
    }
    if(x<r)
    {
        rng.insert({x+1,r});
        ins(r-x);
    }
    return;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>q;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
}
for(int i=0;i<q;i++)
{
    cin>>qr[i].l>>qr[i].r;
    qr[i].num=i;
}

sort(qr,qr+q,cmp);

int l=qr[0].l,r=qr[0].l-1;
rng.insert({-1,-1});
rng.insert({1e9,1e9});
for(int i=0;i<q;i++)
{
    while(l>qr[i].l)
    {
        l--;
        add(a[l]);
    }
    while(r<qr[i].r)
    {
        r++;
        add(a[r]);
    }
    while(l<qr[i].l)
    {
        rem(a[l]);
        l++;
    }
    while(r>qr[i].r)
    {
        rem(a[r]);
        r--;
    }
    auto it=len.end(); it--;
    ans[qr[i].num]=(*it).first;
}

for(int i=0;i<q;i++)
{
    cout<<ans[i]<<endl;
}

return 0;
}
/*
5 5
4 1 2 5 3
1 3
2 5
2 4
3 5
4 5
*/
