#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=1e6+5;

int n,k;
int tree[4*MAXN];
double x[MAXN];
double cur[MAXN];
int ans[MAXN];

void update(int node,int l,int r,int pos)
{
    if(pos<l || r<pos) return;
    if(l==r)
    {
        tree[node]=l;
        return;
    }
    int mid=(l+r)/2;
    update(2*node,l,mid,pos);
    update(2*node+1,mid+1,r,pos);
    if(cur[tree[2*node]]>cur[tree[2*node+1]]) tree[node]=tree[2*node];
    else tree[node]=tree[2*node+1];
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>k;
for(int i=1;i<=n;i++)
{
    cin>>x[i];
    cur[i]=(double) 1/x[i];
    update(1,1,n,i);
}

for(int i=0;i<k;i++)
{
    int ind=tree[1];
    ans[ind]++;
    cur[ind]=(sqrt(ans[ind]+1)-sqrt(ans[ind]))/x[i];
    update(1,1,n,ind);
}

for(int i=1;i<=n;i++)
{
    cout<<ans[i]<<" ";
}
cout<<endl;

return 0;
}
