#include<iostream>
#include<queue>
#include<tuple>
#include<math.h>
#include<algorithm>
using namespace std;

const int MAXN=1e5;

double xs[MAXN];
pair<int, int> ans[MAXN];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    priority_queue<tuple<double, int, double, int> > q;
    for(int i=0; i<n; i++)
    {
        double x;
        cin >> x;

        q.push({1/x, 0, x, i});
        ans[i]={0, i};
    }

    while(k--)
    {
        double profit, x;
        int cnt, idx;

        tie(profit, cnt, x, idx)=q.top();
        q.pop();

        cnt++;
        ans[idx]={cnt, idx};

        profit=sqrt(cnt)/x-sqrt(cnt-1)/x;

        q.push({profit, cnt, x, idx});
    }

    sort(ans, ans+n);

    for(int i=0; i<n-1; i++)
    {
        int cnt, idx;
        tie(cnt, idx)=ans[i];

        int cnt2, idx2;
        tie(cnt2, idx2)=ans[i+1];

        double res1=sqrt(cnt)/xs[idx]+sqrt(cnt2)/xs[idx2];
        double res2=sqrt(cnt-1)/xs[idx]+sqrt(cnt2+1)/xs[idx2];
        double res3=sqrt(cnt+1)/xs[idx]+sqrt(cnt2-1)/xs[idx2];
        if(cnt!=0 && res2>res1)
        {
            ans[i+1].second++;
            ans[i].second--;
        }
        else if(cnt2!=0 && res3>res1)
        {
            ans[i+1].second--;
            ans[i].second++;
        }
    }

    for(int i=0; i<n; i++)
    {
        swap(ans[i].first, ans[i].second);
    }
    sort(ans, ans+n);

    for(int i=0; i<n; i++)
    {
        cout << ans[i].second << " ";
    }

    return 0;
}
