#include<iostream>
#include<queue>
#include<tuple>
#include<math.h>
#include<algorithm>
using namespace std;

const int MAXN=1e5;

long double xs[MAXN];
int ans[MAXN];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    priority_queue<tuple<long double, long long, long double, long long> > q;
    for(int i=0; i<n; i++)
    {
        long double x;
        cin >> x;

        q.push({1/x, 0, x, i});
        ans[i]=0;
    }

    while(k--)
    {
        long double profit, x;
        long long cnt, idx;

        tie(profit, cnt, x, idx)=q.top();
        q.pop();

        cnt++;
        ans[idx]=cnt;

        profit=((cnt)+(cnt+1)-2*sqrt(cnt*(cnt+1)))/(x*x);

        q.push({profit, cnt, x, idx});
    }

    /*sort(ans, ans+n);

    int temp=10;
    while(temp--)
    {
        for(int i=0; i<n-1; i++)
        {
            long long nn, cnt, idx;
            tie(nn, cnt, idx)=ans[i];

            long long nn2, cnt2, idx2;
            tie(nn2, cnt2, idx2)=ans[i+1];

            long double res1=sqrt(cnt)/xs[idx]+sqrt(cnt2)/xs[idx2];
            long double res2=sqrt(cnt-1)/xs[idx]+sqrt(cnt2+1)/xs[idx2];
            long double res3=sqrt(cnt+1)/xs[idx]+sqrt(cnt2-1)/xs[idx2];
            while(cnt!=0 && res2>res1)
            {
                cnt2++;
                cnt--;

                res2=sqrt(cnt-1)/xs[idx]+sqrt(cnt2+1)/xs[idx2];
                res1=sqrt(cnt)/xs[idx]+sqrt(cnt2)/xs[idx2];
            }

            while(cnt2!=0 && res3>res1)
            {
                res3=sqrt(cnt+1)/xs[idx]+sqrt(cnt2-1)/xs[idx2];
                res1=sqrt(cnt)/xs[idx]+sqrt(cnt2)/xs[idx2];

                cnt2--;
                cnt++;
            }

            ans[i]={nn, cnt, idx};
            ans[i+1]={nn2, cnt2, idx2};
        }
    }

    for(int i=0; i<n; i++)
    {
        swap(ans[i].first, ans[i].second);
    }
    sort(ans, ans+n);*/

    for(int i=0; i<n; i++)
    {
        cout << ans[i] << " ";
    }

    return 0;
}
