#include<iostream>
#include<queue>
#include<tuple>
#include<math.h>
#include<algorithm>
using namespace std;

const int MAXN=1e6;

long double xs[MAXN];
long long ans[MAXN];

long long GetNextIdx(long long k, long long cnt, long double x, long double profit, long double profit2)
{
    long long l=cnt, r=cnt+k, ans=cnt;
    while(l<r)
    {
        long long mid=l+(r-l)/2;
        long double p=(sqrt(mid+1)-sqrt(mid))/x;
        if(p>=profit2)
        {
            ans=mid;
            l=mid+1;
        }
        else
        {
            r=mid-1;
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cout << sqrt(10000000)-sqrt(9999999) << "\n";

    long long n, k;
    cin >> n >> k;

    priority_queue<tuple<long double, long long> > q;
    for(int i=0; i<n; i++)
    {
        long double x;
        cin >> x;

        q.push({1/x, i});
        ans[i]=0;
        xs[i]=x;
    }

    while(k>0)
    {
        long double profit;
        long long idx;

        tie(profit, idx)=q.top();
        q.pop();

        long long cnt=ans[idx];
        long double x=xs[idx];

        if(profit < 0.0000000001)
        {
            ans[idx]=cnt+k;
            break;
        }

        long double profit2;
        long long idx2;

        tie(profit2, idx2)=q.top();

        long long newCnt=GetNextIdx(k, cnt+1, x, profit, profit2);

        k-=newCnt-cnt;
        cnt=newCnt;
        ans[idx]=cnt;
        profit=(sqrt(cnt+1)-sqrt(cnt))/x;

        q.push({profit, idx});
    }

    for(int i=0; i<n; i++)
    {
        cout << ans[i] << " ";
    }
    cout << "\n";

    return 0;
}
