#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

const int maxn = 2e+5+5;
const int siz = maxn<<2;

struct node
{
    int l, r;
};

node tree[siz];
int index[maxn], n, q, ql, qr;

bool check(int number)
{
    return (ql <= index[number] && index[number] <= qr);
}

int answer = 1;
void fmerge(node& p, const node& lnode, const node& rnode)
{
    if(lnode.l == lnode.r && lnode.l != 0 && rnode.l == rnode.r && rnode.l != 0)
    {
        p.l = p.r = lnode.r + rnode.l;
    }
    else if(lnode.l == lnode.r && lnode.l != 0)
    {
        p.l = lnode.r + rnode.l;
        p.r = rnode.r;
    }
    else if(rnode.l == rnode.r && rnode.l != 0)
    {
        p.l = lnode.l;
        p.r = lnode.r + rnode.l;
    }
    else
    {
        p.l = lnode.l;
        p.r = rnode.r;
    }
    // cout << p.l << " " << p.r << endl;
    answer = max(answer, max(max(p.l, p.r), lnode.r + rnode.l));
}

void query(int k, int l, int r)
{
    if(l == r)
    {
        tree[k].l = tree[k].r = check(l);
        return;
    }
    int mid = (l + r) >> 1;
    query((k << 1) + 0, l, mid + 0);
    query((k << 1) + 1, mid + 1, r);
    // cout << "k: " << k << ", l: " << l << ", r: " << r << " - ";
    fmerge(
        tree[k],
        tree[(k << 1) + 0],
        tree[(k << 1) + 1]
    );
    // cout << endl;
}

int main()
{

    cin >> n >> q;
    for(int i = 1; i <= n; i++)
    { cin >> ql; index[ql] = i; }
    for(int i = 0; i < q; i++)
    {
        cin >> ql >> qr;
        answer = 1;
        query(1, 1, n);
        cout << answer << endl;
    }
    return 0;
}

/*
4 2
2 4 1 3
1 4
2 4
*/

