#include<bits/stdc++.h>
#define endl "\n"

#define pii pair<int, int>
#define ff first
#define ss second

#define vii vector<pii>

using namespace std;

const int maxn = 2e+5+5;
const int siz = maxn<<2;

vii empty_set;
vii tree[siz];
int arr[maxn];
int n, q, ql, qr;

int mdiff = 0;
vii normalize(vii& v)
{
    mdiff = 0; vii ret; int ind = 0, anch;
    while(ind < v.size())
    {
        anch = ind; ind++;
        while(ind < v.size() && v[anch].ss == v[ind].ff - 1)
        {
            v[anch].ss = v[ind].ss;
            ind++;
        }
        mdiff = max(mdiff, v[anch].ss - v[anch].ff + 1);
        ret.emplace_back(v[anch].ff, v[anch].ss);
    }
    return ret;
}

vii combine(const vii& a, const vii& b)
{
    int ai = 0, anch, bi = 0;
    vii ret;
    while(ai < a.size() && bi < b.size())
    {
        if(a[ai].ss < b[bi].ff)
        {
            ret.emplace_back(a[ai].ff, a[ai].ss);
            ai++;
        }
        else
        {
            ret.emplace_back(b[bi].ff, b[bi].ss);
            bi++;
        }
    }
    while(ai < a.size()) ret.emplace_back(a[ai].ff, a[ai].ss), ai++;
    while(bi < b.size()) ret.emplace_back(b[bi].ff, b[bi].ss), bi++;
    return normalize(ret);
}

void print(const vii& intervals)
{
    for(int i = 0; i < intervals.size(); i++)
        cout << "(" << intervals[i].ff  << ", "
             << intervals[i].ss << ") ";
     cout << endl;
}

int eval(const vii& v)
{
    int mx = 0;
    for(size_t i = 0; i < v.size(); i++)
        mx = max(mx, v[i].ss - v[i].ff + 1);
    return mx;
}

void build(int k, int l, int r)
{
    if(l == r)
    {
        tree[k].emplace_back(arr[l], arr[l]);
        return;
    }
    int mid = (l + r) >> 1;
    // cout << k;
    build((k << 1) + 0, l, mid + 0);
    build((k << 1) + 1, mid + 1, r);
    tree[k] = combine(tree[(k << 1) + 0], tree[(k << 1) + 1]);
}

vii query(int k, int l, int r)
{
    if(r < ql || qr < l) return empty_set;
    if(ql <= l && r <= qr) return tree[k];
    int mid = (l + r) >> 1;
    vii lc = query((k << 1) + 0, l, mid + 0);
    vii rc = query((k << 1) + 1, mid + 1, r);
    return combine(lc, rc);
}

int main()
{
    cin >> n >> q;
    for(int i = 1; i <= n; i++)
        cin >> arr[i];
    build(1, 1, n);
    for(int i = 0; i < q; i++)
    {
        cin >> ql >> qr;
        cout << eval(query(1, 1, n)) << endl;
    }
    return 0;
}
