#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=2e5+10;
vector <pair <int,int> > que[MAXN];
int a[MAXN], dsu[MAXN], ss[MAXN], ran[MAXN];
int ans[MAXN];
int n, maxc;
int root(int x) {
    if (dsu[x]==x) return x;
    return dsu[x]=root(dsu[x]);
}
void connect(int u, int v) {
    if (v==n+1 || v==0 || dsu[v]==-1) return;
    int r1, r2;
    r1=root(u); r2=root(v);
    if (r1==r2) return;
    if (ran[r1]<ran[r2]) swap(r1,r2);
    dsu[r2]=r1;
    ss[r1]+=ss[r2];
    if (ran[r1]==ran[r2]) ran[r1]++;
    maxc=max(maxc,ss[r1]);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> n >> q;
    for (int i=1;i<=n;i++) cin >> a[i];
    int l, r;
    for (int i=0;i<q;i++) {
        cin >> l >> r;
        que[l].push_back({r,i});
    }
    for (int i=1;i<=n;i++) dsu[i]=-1;
    for (int i=1;i<=n;i++) {
        if (que[i].empty()) continue;
        sort(que[i].begin(),que[i].end());
        int br=0, gr=i;
        maxc=1;
        for (int j=i;j<=n;j++) {
            dsu[a[j]]=a[j];
            ss[a[j]]=ran[a[j]]=1;
            connect(a[j],a[j]+1);
            connect(a[j],a[j]-1);
            while (br<que[i].size() && que[i][br].first==j) {
                ans[que[i][br].second]=maxc;
                br++;
            }
            if (br==que[i].size()) {
                gr=j;
                break;
            }
        }
        for (int j=i;j<=gr;j++) dsu[a[j]]=-1;
    }
    for (int i=0;i<q;i++) cout << ans[i] << endl;
    return 0;
}

