#include <iostream>
using namespace std;
bool check_pow(long long a, long long b, long long m) {
    long long st=1;
    for (int i=1;i<b;i++) {
        st*=a;
        if (st>m/a) return false;
    }
    return true;
}
bool check(long long n, long long m) {
    for (int i=2;i<=n-1;i++) {
        if (!check_pow(i,n-i-1,m)) return false;
    }
    return true;
}
long long power(long long a, long long b) {
    if (b==0) return 1;
    if (b%2==0) {
        long long s=power(a,b/2);
        return s*s;
    }
    return a*power(a,b-1);
}
long long solve(long long n, long long m, long long gr) {
    ///cout << n << ' ' << m << ' ' << gr << endl;
    if (n==1) return m-gr;
    long long ans=0;
    for (long long i=gr+1;i<m-n+1 && check_pow(i,n,m);i++) ans+=solve(n-1,m,power(i,n)-1);
    return ans;
}
int main () {
    long long n, m;
    cin >> n >> m;
    if (!check(n,m)) cout << 0 << endl;
    else cout << solve(n-1,m,1)+solve(n,m,1) << endl;
    return 0;
}
