#include <iostream>
using namespace std;
long long mod=1050000011;
bool check_pow(long long a, long long b, long long m) {
    if (a==1) return true;
    long long st=1;
    for (int i=1;i<b;i++) {
        st*=a;
        if (st>m/a) return false;
    }
    return true;
}
long long power(long long a, long long b) {
    if (a==1) return 1;
    if (b==0) return 1;
    if (b%2==0) {
        long long s=power(a,b/2);
        return s*s;
    }
    return a*power(a,b-1);
}
long long solve(long long n, long long m, long long gr) {
    cout << n << ' ' << m << ' ' << gr << endl;
    if (n==1) return m-gr+1;
    long long ans=0;
    for (long long i=gr;i<=m-n+1 && check_pow(i,n,m);i++) ans+=solve(n-1,m,power(i,n));
    return ans%mod;
}
int main () {
    long long n, m;
    cin >> n >> m;
    cout << solve(n,m,1) << endl;
    return 0;
}
