#include <iostream>
#include <unordered_map>
using namespace std;
int mod=1050000011;
int m;
int check_pow(int a, int b, int ch) {
    if (a==1 || b==0) {
        if (ch==0) return -1;
        return 1;
    }
    if (b%2==0) {
        int s=check_pow(a,b/2,ch);
        if (s==-1 || ch/s<s) return -1;
        return s*s;
    }
    int s=check_pow(a,b-1,ch);
    if (s==-1 || ch/s<a) return -1;
    return a*s;
}
int power(int a, int b) {
    if (a==1) return 1;
    if (b==0) return 1;
    if (b%2==0) {
        int s=power(a,b/2);
        return s*s;
    }
    return a*power(a,b-1);
}
int f(int a, int b) {
    int l, r, mid;
    l=1; r=m;
    while (l<=r) {
        mid=(l+r)/2;
        if (check_pow(mid,b,a-1)!=-1) l=mid+1;
        else r=mid-1;
    }
    return l;
}
int solve(int n, int gr) {
    ///cout << n << ' ' << m << ' ' << gr << endl;
    if (n==1) return m-gr+1;
    int ans=0;
    for (int i=gr;i<=m && check_pow(i,n,m)!=-1;i++) ans+=solve(n-1,f(power(i,n),n-1));
    return ans%mod;
}
int main () {
    int n;
    cin >> n >> m;
    cout << solve(n,1) << endl;
    return 0;
}
