#include<iostream>
#include<vector>
using namespace std;

const int MAX_SIZE = 2*10e5;

int nums[MAX_SIZE];
vector<pair<int, int>> longest[MAX_SIZE];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; ++i) {
        int value;
        cin >> value;
        nums[i] = value;
        longest[i].push_back({ i, 1 });
    }

    for (int i = 0; i < n; ++i) {
        vector<pair<int, int>> missing;
        int maxn = i, minn = i;

        int curr = 1;
        for (int j = i; j < n; ++j) {
            if (nums[j] > nums[maxn]) {
                if (nums[j] - nums[maxn] > 1) {
                    missing.push_back({ nums[maxn] + 1, nums[j] - 1 });
                }
                maxn = j;
            }
            if (nums[j] < nums[minn]) {
                if (nums[minn] - nums[j] > 1) {
                    missing.push_back({ nums[j] + 1, nums[minn] - 1 });
                }
                minn = j;
            }

            for (int k = missing.size() - 1; k >= 0; --k) {
                if (!(nums[j] >= missing[k].first && nums[j] <= missing[k].second))
                    continue;

                if (missing[k].first == missing[k].second) {
                    missing.erase(missing.begin() + k, missing.begin() + k + 1);
                    continue;
                }
                if (missing[k].first == nums[j]) {
                    ++missing[k].first;
                    continue;
                }
                if (missing[k].second == nums[j]) {
                    --missing[k].second;
                    continue;
                }

                missing.push_back({ missing[k].first, nums[j] - 1 });
                missing.push_back({ nums[j] + 1, missing[k].second });
            }

            int old = curr;
            if (missing.size() == 0) {
                if (j - i + 1 > curr)
                    curr = j - i + 1;
            }else{
                if (missing[0].first - nums[minn] > curr) {
                    curr = missing[0].first - nums[minn];
                }

                if (nums[maxn] - missing[missing.size() - 1].second > curr) {
                    curr = nums[maxn] - missing[missing.size() - 1].second;
                }

                for (int k = 0; k < missing.size() - 1; ++k)
                    if (missing[k + 1].first - missing[k].second - 1 > curr)
                        curr = missing[k + 1].first - missing[k].second - 1;
            }

            if (old != curr) {
                longest[i].push_back({ j, curr });
            }
        }
    }

    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;

        for (int k = 0; k < longest[l].size(); ++k) {
            if (r >= longest[l][k].first && k == longest[l].size() - 1) {
                cout << longest[l][k].second << endl;
                break;
            }
            if (r >= longest[l][k].first && r < longest[l][k + 1].first) {
                cout << longest[l][k].second << endl;
                break;
            }
        }
    }

    return 0;
}
