#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

struct event{
    int type,tim,pos,val;
};

const int bucket_sz=400;
int n,q,l,r,dsu[MAXN],sz[MAXN];
int p[MAXN],bucket[MAXN],tim,ans;
bool in[MAXN];
stack<event> st;

struct qr{
    int l,r,id;

    inline friend bool operator < (qr fr,qr sc){
        if(bucket[fr.l]!=bucket[sc.l])return bucket[fr.l] < bucket[sc.l];
        return fr.r<sc.r;
    }
};

qr qs[MAXN];

void reset(){
    for(int i=1;i<=n;i++){
        dsu[i]=i; sz[i]=1; in[i]=false;
    }
    while(!st.empty())st.pop();
    tim=0; ans=1;
}

int root(int x){
    if(dsu[x]==x)return x;
    return root(dsu[x]);
}

void mergev(int x,int y){
    tim++;
    int rootx=root(x);
    int rooty=root(y);

    if(sz[rootx]<sz[rooty])swap(rootx,rooty);
    st.push({1,tim,rooty,rooty});
    st.push({2,tim,rootx,sz[rootx]});
    st.push({3,tim,0,ans});

    dsu[rooty]=rootx;
    sz[rootx]+=sz[rooty];
    ans=max(ans,sz[rootx]);
}

void undo(){
    while(!st.empty() and st.top().tim==tim){
        if(st.top().type==1){
            dsu[st.top().pos]=st.top().val;
        }else if(st.top().type==2){
            sz[st.top().pos]=st.top().val;
        }else{
            ans=st.top().val;
        }
        st.pop();
    }
    tim--;
}

void add(int x){
    if(in[x-1])mergev(x-1,x);
    if(in[x+1])mergev(x+1,x);
    in[x]=true;
}

void rem(int x){
    if(in[x-1])undo();
    if(in[x+1])undo();
    in[x]=false;
}

int main(){

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>p[i];
        bucket[i]=i/bucket_sz;
    }

    for(int i=1;i<=q;i++){
        cin>>l>>r;
        qs[i]={l,r,i};
    }

    sort(qs+1,qs+q+1);

    l=1; r=0;
    for(int i=1;i<=q;i++){
        if(i==1 or bucket[qs[i].l]!=bucket[qs[i-1].l]){
            reset();
        }
        while(r<qs[i].r){
            r++; add(r);
        }
        while(l>qs[i].l){
            l--; add(l);
        }
        while(r>qs[i].r){
            add(r); r--;
        }
        while(l<qs[i].l){
            add(l); l++;
        }
    }

    return 0;
}

