#include<bits/stdc++.h>
using namespace std;

long long n,m;

const long long mod=1050000011;

long long root(long long x,long long y){
    return pow(x,1.0/y);
}

long long power(long long x,long long y){
    if(y==0)return 1;
    if(y==1)return x;
    if(y==2)return x*x;
    if(y%2==0)return power(power(x,y/2),2);
    return power(power(x,y/2),2)*x;
}

long long pref[10000007];
long long dp[65][1000007];

long long brute(int pos,long long last){
    if(pos==1)return (m-power(last,2)+1)%mod;
    if(pos==2){
        long long from=root(last*last*last,2);
        if(from*from<last*last*last)from++;
        long long to=root(m,2);

        return ( (m+1)*(to-from+1)%mod-(pref[to]-pref[from-1]+mod)+mod)%mod;
    }

    if(last<=1000000){
        if(dp[pos][last]>0)return dp[pos][last];

        for(long long i=root(power(last,pos+1),pos);i<=root(m,pos);i++){
            if(power(i,pos)<power(last,pos+1))continue;
            dp[pos][last]+=brute(pos-1,i);
            dp[pos][last]%=mod;
        }

        return dp[pos][last];
    }else{
        long long res=0;

        for(long long i=root(power(last,pos+1),pos);i<=root(m,pos);i++){
            if(power(i,pos)<power(last,pos+1))continue;
            res+=brute(pos-1,i);
            res%=mod;
        }

        return res;
    }
}

int main(){

    for(long long i=1;i<=10000000;i++){
        pref[i]=(pref[i-1]+i*i)%mod;
    }

    cin>>n>>m;
    n=min(n,64LL);
    cout<<brute(n,1)<<"\n";

    return 0;
}

