#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast, unroll-loops")
// #pragma GCC target("avx2, tune=native")
#define endl "\n"

using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

typedef long long ll;
const ll mod = 1e9 +7;

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int MAX_N = 2e5 + 10;

ll par[MAX_N], sz[MAX_N];

int find(int x) {
    if(par[x] == x) {
        return x;
    } else {
        return par[x] = find(par[x]);
    }
}

int best = 0;

void merge(int x, int y) {
    x = find(x); y = find(y);
    if(x == y) {
        return;
    }
    if(sz[x] < sz[y]) { swap(x, y); }
    par[y] = x;
    sz[x] += sz[y];
    chkmax(best, sz[x]);
}

bool on[MAX_N];
int n, q, arr[MAX_N];

void add(int x) {
    if(x != 0 && on[x - 1]) {
        merge(x, x - 1);
    }
    if(x != n - 1 && on[x + 1]) {
        merge(x, x + 1);
    }
    on[x] = true;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
        arr[i] --;
    }
    for(int i = 0; i < n; i ++) {
        par[i] = i;
        sz[i] = 1;
    }

    for(int i = 0; i < q; i ++) {
        int l, r;
        cin >> l >> r;
        l --;
        r --;

        best = 1;
        for(int i = l; i <= r; i ++) {
            add(arr[i]);
        }
        cout << best << endl;
        for(int i = l; i <= r; i ++) {
            on[i] = false;
            par[i] = i;
            sz[i] = 1;
        }
    }


    return 0;
}

