#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast, unroll-loops")
// #pragma GCC target("avx2, tune=native")
#define endl "\n"

using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

typedef long long ll;
const ll mod = 1e9 +7;

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int MAX_N = 1e6 + 10;
ll n, k;
double arr[MAX_N];

double calc(int i, ll x, double lambda) {
    return sqrt((double)x) / arr[i] + lambda * x;
}

int ans[MAX_N];

pair<double, ll> eval(double lambda) {
    double ret = 0;
    ll cnt = 0;
    cerr << "Starting " << lambda << endl;
    for(int i = 0; i < n; i ++) {
        ll l = 0;
        ll r = k + 1;
        while(l < r - 1) {
            ll m = (l + r) / 2ll;
            if(sqrt(m + 1) - sqrt(m) > lambda * arr[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        for(int j = 1; j <= k; j ++) {
            cerr << (sqrt(j + 1) - sqrt(j)) / arr[i] << " ";
        }
        cerr << endl;
        ret += calc(i, r, lambda);
        cnt += r;
        ans[i] = r;
    }
    return {ret, cnt};
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    cin >> n >> k;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
    }

    priority_queue<pair<double, int> > pq;
    for(int i = 0; i < n; i ++) {
        pq.push({(double)1 / arr[i], i});
    }
    double ret = 0;
    while(k --) {
        auto curr = pq.top(); pq.pop();
        ret += curr.first;
        ans[curr.second] ++;
        pq.push({(sqrt(ans[curr.second] + 1) - sqrt(ans[curr.second])) / arr[curr.second], curr.second});
    }

    for(int i = 0; i < n; i ++) {
        cout << ans[i] << " ";
    }
    cout << endl;

    return 0;
    double l = -1e16, r = 1e16;
    for(int iter = 0; iter < 70; iter ++) {
        double m = (l + r) / 2ll;
        if(eval(m).second <= k) {
            r = m;
        } else {
            l = m;
        }
    }

    cout << eval(r).first << " " << eval(r).second << endl;
    for(int i = 0; i < n; i ++) {
        cout << ans[i] << " ";
    }
    cout << endl;

    return 0;
}
