#include <bits/stdc++.h>
#pragma GCC optimize("Ofast, unroll-loops")
#pragma GCC target("avx2")
#define endl "\n"

using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

typedef long long ll;
const ll mod = 1e9 +7;

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int MAX_N = 1e6 + 10;
ll n, k;
double arr[MAX_N];

double calc(int i, ll x, double lambda) {
    return sqrt((double)x) / arr[i] + lambda * x;
}

ll ans[MAX_N];

ll eval(double lambda) {
    ll cnt = 0;
    for(int i = 0; i < n; i ++) {
        double A = arr[i] * lambda;
        double aux = (1 - A * A) / (2 * A);
        ll m;
        if(aux < 0) {
            m = 0;
        } else {
            m = ceil(aux * aux);
        }
        cnt += m;
        ans[i] = m;
    }
    return cnt;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    cin >> n >> k;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
    }

    double l = 0, r = 1e12;
    for(int iter = 0; iter < 60; iter ++) {
        double m = (l + r) / 2ll;
        if(eval(m) < k) {
            r = m;
        } else {
            l = m;
        }
    }

    k -= eval(r);

    priority_queue<pair<double, int> > pq;
    for(int i = 0; i < n; i ++) {
        pq.push({(sqrt(ans[i] + 1) - sqrt(ans[i])) / arr[i], i});
    }
    double ret = 0;
    while(k --) {
        auto curr = pq.top(); pq.pop();
        ret += curr.first;
        ans[curr.second] ++;
        pq.push({(sqrt(ans[curr.second] + 1) - sqrt(ans[curr.second])) / arr[curr.second], curr.second});
    }

    for(int i = 0; i < n; i ++) {
        cout << ans[i] << " ";
    }
    cout << endl;

    return 0;
}
