#include<bits/stdc++.h>
using namespace std;
#define MAXN 200007
int ar[MAXN],n,qq,bsize;
struct node
{
    int sz;
    int lg=0;
    int ll=0,rr=0;
} seg[4*MAXN];
struct query
{
    int l,r,ind;
} qu[MAXN];
int ans[MAXN];
bool cmp(query &a, query &b)
{
    if (a.l / bsize == b.l / bsize)
    {
        return a.r<b.r;
    }
    return a.l<b.l;
}
void Initialise(int ind, int l, int r)
{
    seg[ind].sz=r-l+1;
    if (l==r) return;
    int mid=(l+r)/2;
    Initialise(ind*2,l,mid);
    Initialise(ind*2+1,mid+1,r);
}
void Update(int ind, int l, int r, int up, bool ad)
{
    if (l==r && l==up)
    {
        if (ad)
        {
            seg[ind].lg = 1;
            seg[ind].ll=1;
            seg[ind].rr=1;
        }
        else
        {
            seg[ind].lg=0;
            seg[ind].ll=0;
            seg[ind].rr=0;
        }
        return;
    }
    int mid=(l+r)/2;
    if (up<=mid) Update(ind*2,l,mid,up,ad);
    if (up>=mid+1) Update(ind*2+1,mid+1,r,up,ad);
    seg[ind].lg = max(seg[ind*2].lg,seg[ind*2+1].lg);
    seg[ind].lg = max(seg[ind].lg, seg[ind*2].rr+seg[ind*2+1].ll);
    if (seg[ind*2+1].rr == seg[ind*2+1].sz) seg[ind].rr = seg[ind*2].rr+seg[ind*2+1].sz;
    else seg[ind].rr = seg[ind*2+1].rr;
    if (seg[ind*2].ll == seg[ind*2].sz ) seg[ind].ll = seg[ind*2+1].ll + seg[ind*2].sz;
    else seg[ind].ll = seg[ind].ll;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>qq;
    bsize = n/sqrt(qq);
    for (int q=1;q<=n;q++) cin>>ar[q];
    for (int q=0;q<qq;q++)
    {
        qu[q].ind=q;
        cin>>qu[q].l>>qu[q].r;
    }
    Initialise(1,1,n);
    sort(qu,qu+qq,cmp);
    int cl=1,cr=1;
    Update(1,1,n,ar[1],1);
    for (int q=0;q<qq;q++)
    {
        int ql = qu[q].l;
        int qr = qu[q].r;
        //cout<<ql<<" "<<qr<<"\n";
        while (cl>ql)
        {
            cl--;
            Update(1,1,n,ar[cl],1);
        }
        while (cr<qr)
        {
            cr++;
            Update(1,1,n,ar[cr],1);
        }
        while (cl<ql)
        {
            Update(1,1,n,ar[cl],0);
            cl++;
        }
        while (cr>qr)
        {
            Update(1,1,n,ar[cr],0);
            cr--;
        }
        ans[qu[q].ind] = seg[1].lg;
    }
    for (int q=0;q<qq;q++)
    {
        cout<<ans[q]<<"\n";
    }
}
