#include <iostream>
#include <fstream>
#include <math.h>
#include <iomanip>
#include <vector>
using namespace std;

const int MAXN = 200000;

int n,q;
int a[MAXN];
bool has[MAXN+1];
vector<int> ans;

pair<int,int> miMa(int l,int r)
{
	int mi=a[l],ma=a[l];
	for(int i=l;i<=r;i++)
	{
		if(mi>a[i]) mi=a[i];
		if(ma<a[i]) ma=a[i];
	}
	
	return make_pair(mi,ma);
}

void init()
{
	ios_base::sync_with_stdio(0);
	
	scanf("%d%d",&n,&q);
	
	for(int i=0;i<n;i++)
	{	
		scanf("%d",&a[i]);
	}
}

int main()
{
	init();
	
	for(int i=0;i<q;i++)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		
		pair<int,int> mm = miMa(x-1,y-1);
		
		for(int j=mm.first;j<=mm.second;j++)
			has[j]=false;
		
		for(int j=x-1;j<y;j++)
			has[a[j]] = true;
		
		int cnt = 0, mcnt = 1;
		for(int j=mm.first;j<=mm.second;j++)
		{
			if(has[j]) cnt++;
			if(cnt>mcnt) mcnt=cnt;
			if(!has[j]) cnt=0;
		}
		
		ans.push_back(mcnt);
	}
	
	for(int i=0;i<q;i++)
		printf("%d\n",ans[i]);
}
/*
4 2
2 4 1 3
1 4
2 4
*/
