#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;
int n, a[maxn], q, bef[maxn], aft[maxn];

void solve_query(int l, int r)
{
    for (int i = l; i <= r; i ++)
    {
        int bf = bef[a[i]], af = aft[a[i]];
        bef[af] = bf;
        aft[bf] = af;
    }

    int ans = 0;
    for (int i = l; i <= r; i ++)
    {
        int c = a[i];
        ans = max(ans, aft[c] - bef[c] - 1);
        aft[c] = c + 1;
        bef[c] = c - 1;
    }

    cout << ans << endl;
}
void solve()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n; i ++)
    {
        bef[i] = i - 1;
        aft[i] = i + 1;
    }

    for (int i = 1; i <= q; i ++)
    {
        int l, r;
        cin >> l >> r;
        solve_query(l, r);
    }

}

int main()
{
    speed();
    solve();
    return 0;
}
