#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e6 + 10;

struct element
{
    double bonus;
    int idx;

    element(double _bonus, int _idx)
    {
        bonus = _bonus;
        idx = _idx;
    }

    bool operator < (const element &e) const
    {
        return bonus < e.bonus;
    }
};

int n;
ll k;
pair < double, ll > x[maxn];
double work[maxn];
ll ans[maxn];
const double eps = 1e-10;

ll check(double nec)
{
    ll sum = 0;
    for (int i = 1; i <= n; i ++)
    {
        ll lf = 0, rf = k;
        while(lf <= rf)
        {
            ll mf = (lf + rf) / 2;
            double get = sqrt(mf + 1) / x[i].first -
                         sqrt(mf) / x[i].first;
            ///cout << i << " : " << lf << " " << rf << " " << get << " " << nec << endl;
            if (get > nec)
                lf = mf + 1;
            else
                rf = mf - 1;
        }
        sum += lf;
        ///ll cur = (ceil)((x[i].first * nec) * (x[i].first * nec));
        ///cout << cur << " nec " << nec << endl;

    }
    return sum;
}
void solve()
{
    cin >> n >> k;
    for (int i = 1; i <= n; i ++)
    {
        cin >> x[i].first;
    }
    //cout << check(0.25) << endl;
    //return;
    double lf = 0, rf = 1e4;
    for (int i = 0; i < 30; i ++)
    {
        double mf = (lf + rf) / 2;
        if (check(mf) > k)
            lf = mf;
        else
            rf = mf;
    }


    /**for (int i = 1; i <= n; i ++)
    {
        for (int j = 1; j <= k; j ++)
        {double gt = sqrt(j) / x[i].first - sqrt(j - 1) / x[i].first;
            cout << gt << " ";
        }
        cout << endl;
    }*/


    double nec = rf;
    ///cout << nec << " " << check(lf) << " " << check(rf) << endl;
    ll left = k;
    for (int i = 1; i <= n; i ++)
    {
        ll lf = 0, rf = k;
        while(lf <= rf)
        {
            ll mf = (lf + rf) / 2;
            double get = sqrt(mf + 1) / x[i].first -
                         sqrt(mf) / x[i].first;
            ///cout << i << " : " << lf << " " << rf << " " << get << " " << nec << endl;
            if (get > nec)
                lf = mf + 1;
            else
                rf = mf - 1;
        }
        work[i] = lf;
        left -= lf;
    }

    k = left;

    priority_queue < element > pq;
    for (int i = 1; i <= n; i ++)
    {
        double gt = (double)(sqrt(work[i] + 1)) / x[i].first -
                    (double)(sqrt(work[i])) / x[i].first;
        pq.push(element(gt, i));
    }
    for (int j = 1; j <= k; j ++)
    {
        element cur = pq.top();
        pq.pop();
        work[cur.idx] ++;
        int i = cur.idx;
        double gt = (double)(sqrt(work[i] + 1)) / x[i].first -
                    (double)(sqrt(work[i])) / x[i].first;
        pq.push(element(gt, i));

    }


    for (int i = 1; i <= n; i ++)
        cout << work[i] << " ";
    cout << endl;

}

int main()
{
    speed();
    solve();
    return 0;
}
/**

*/
