#include<bits/stdc++.h>
#pragma GCC optimize ("O3, unroll-loops")
using namespace std;

const int maxn = 15e3+2;
int n, q, a[maxn], cnt[maxn];
struct tree
{
    int left, right;
    int len;
};
tree t[4*maxn];

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i].left = t[i].right = t[i].len = cnt[r];
        //cout << l << " " << r << " : " << t[i].left << " " << t[i].right << " " << t[i].len << '\n' ;
        return;
    }
    int mid = (l+r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);

    t[i].left = t[2*i].left;
    if (t[2*i].left == mid-l+1)
        t[i].left += t[2*i+1].left;

    t[i].right = t[2*i+1].right;
    if (t[2*i+1].right == r-mid)
        t[i].right += t[2*i].right;

    t[i].len = max(max(max(t[i].left, t[i].right), max(t[2*i].len, t[2*i+1].len)), t[2*i].right + t[2*i+1].left);
    //cout << l << " " << r << " : " << t[i].left << " " << t[i].right << " " << t[i].len << '\n' ;
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> q ;
    int i;
    for (i=1; i<=n; ++i)
        cin >> a[i] ;

    int j, ql, qr, l, r;
    for (i=1; i<=q; ++i)
    {
        cin >> ql >> qr ;
        memset(cnt, 0, sizeof(cnt));
        l = n, r = 1;
        for (j=ql; j<=qr; ++j)
            ++ cnt[a[j]];
        make_tree(1, 1, n);
        cout << t[1].len << '\n' ;
    }
}

int main()
{
    read();
    return 0;
}

/*
16 1
14 10 6 1 15 12 4 7 13 5 8 16 2 3 9 11
5 14
*/