#include<bits/stdc++.h>
//#pragma GCC optimize ("O3, unroll-loops")
using namespace std;

const int maxn = 15e3+2;
int n, k, a[maxn], cnt[maxn], idx, val, ans[maxn], c;
struct tree
{
    int left, right;
    int len;
};
tree t[4*maxn];
struct query
{
    int from, to;
    int idx;
};
query q[maxn];

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i].left = t[i].right = t[i].len = cnt[r];
        //cout << l << " " << r << " : " << t[i].left << " " << t[i].right << " " << t[i].len << '\n' ;
        return;
    }
    int mid = (l+r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);

    t[i].left = t[2*i].left;
    if (t[2*i].left == mid-l+1)
        t[i].left += t[2*i+1].left;

    t[i].right = t[2*i+1].right;
    if (t[2*i+1].right == r-mid)
        t[i].right += t[2*i].right;

    t[i].len = max(max(max(t[i].left, t[i].right), max(t[2*i].len, t[2*i+1].len)), t[2*i].right + t[2*i+1].left);
    //cout << l << " " << r << " : " << t[i].left << " " << t[i].right << " " << t[i].len << '\n' ;
}

void update(int i, int l, int r)
{
    if (l == r)
    {
        t[i].left = t[i].right = t[i].len = val;
        //cout << l << " " << r << " : " << t[i].left << " " << t[i].right << " " << t[i].len << '\n' ;
        return;
    }
    int mid = (l+r) >> 1;
    if (idx <= mid) update(2*i, l, mid);
    else update(2*i+1, mid+1, r);

    t[i].left = t[2*i].left;
    if (t[2*i].left == mid-l+1)
        t[i].left += t[2*i+1].left;

    t[i].right = t[2*i+1].right;
    if (t[2*i+1].right == r-mid)
        t[i].right += t[2*i].right;

    t[i].len = max(max(max(t[i].left, t[i].right), max(t[2*i].len, t[2*i+1].len)), t[2*i].right + t[2*i+1].left);
    //cout << l << " " << r << " : " << t[i].left << " " << t[i].right << " " << t[i].len << '\n' ;
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    c = sqrt(k);
    int i;
    for (i=1; i<=n; ++i)
        cin >> a[i] ;

    for (i=1; i<=k; ++i)
    {
        cin >> q[i].from >> q[i].to ;
        q[i].idx = i;
    }
}

bool cmp(query q1, query q2)
{
    /*int l1 = q1.from % c, l2 = q2.from % c;
    if (l1 == l2) return (q1.to < q2.to);
    return (l1 < l2);*/

    int l1 = q1.from % c, l2 = q2.from % c;
    if (q1.to == q2.to) return (l1 < l2);
    return (q1.to < q2.to);
}

void solve()
{
    //cout << c << '\n' ;
    sort(q+1, q+k+1, cmp);

    int i, j;
    for (j=q[1].from; j<=q[1].to; ++j)
        ++ cnt[a[j]];
    make_tree(1, 1, n);
    ans[q[1].idx] = t[1].len ;

    for (i=2; i<=k; ++i)
    {
        //cout << '\n' << q[i].idx << '\n' << '\n' ;
        if (q[i-1].from < q[i].from)
        {
            for (j=q[i-1].from; j<q[i].from; ++j)
            {
                idx = a[j], val = 0;
                update(1, 1, n);
                //cout << idx << "*" << val << '\n' ;
            }
        }
        else
        {
            for (j=q[i].from; j<q[i-1].from; ++j)
            {
                idx = a[j], val = 1;
                update(1, 1, n);
                //cout << idx << "*" << val << '\n' ;
            }
        }

        if (q[i-1].to < q[i].to)
        {
            for (j=q[i-1].to+1; j<=q[i].to; ++j)
            {
                idx = a[j], val = 1;
                update(1, 1, n);
                //cout << idx << "*" << val << '\n' ;
            }
        }
        else
        {
            for (j=q[i].to+1; j<=q[i-1].to; ++j)
            {
                idx = a[j], val = 0;
                update(1, 1, n);
                //cout << idx << "*" << val << '\n' ;
            }
        }
        ans[q[i].idx] = t[1].len;
    }

    for (i=1; i<=k; ++i)
        cout << ans[i] << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}

/*
16 3
14 10 6 1 15 12 4 7 13 5 8 16 2 3 9 11
5 14
6 14
6 13
*/