#include<bits/stdc++.h>
//#pragma GCC optimize ("O3, unroll-loops")
using namespace std;

const int maxn = 16, maxk = 16;
int n, k, g, ans[maxn];
double dp[maxn][maxk], squared[12];
pair <double, int> x[maxn];
int path[maxn][maxk];

void init()
{
    squared[1] = 1;
    squared[2] = 1.4142135624;
    squared[3] = 1.7320508076;
    squared[4] = 2;
    squared[5] = 2.2360679775;
    squared[6] = 2.4494897428;
    squared[7] = 2.6457513111;
    squared[8] = 2.8284271247;
    squared[9] = 3;
    squared[10] = 3.1622776602;
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    g = min(n, k);
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> x[i].first ;
        x[i].second = i;
    }
}

void solve()
{
    sort(x+1, x+n+1);
    int i, j, l;
    double res, t;
    for (i=1; i<=g; ++i)
    {
        for (j=1; j<=k; ++j)
        {
            res = 0;
            for (l=0; l<=j; ++l)
            {
                t = dp[i-1][j-l] + (squared[l] / x[i].first);
                if (t > res)
                {
                    res = t;
                    path[i][j] = l;
                }
            }
            dp[i][j] = res;
            //cout << i << " " << j << " " << dp[i][j] << " " << path[i][j] << '\n' ;
        }
    }
}

void print()
{
    int i = g, j = k;
    while (i > 0)
    {
        ans[x[i].second] = path[i][j];
        j -= path[i][j];
        -- i;
    }

    for (i=1; i<=n; ++i)
        cout << ans[i] << " " ;
    cout << '\n' ;
}

int main()
{
    init();
    read();
    solve();
    print();
    return 0;
}