#include<bits/stdc++.h>
using namespace std;
const int maxn = 2e5 + 10;
int n, q, a[maxn];
int posnum[maxn];
bool cntsort[maxn];
vector<int> v[maxn];
bool used[maxn];
int Query_stupid(int l, int r){
    vector<int> seq;
    for (int i = l; i <= r; ++i)
        seq.push_back(a[i]);
    sort(seq.begin(), seq.end());
    /*cout << "seq: ";
    for (int i = 0; i < seq.size(); ++i)
        cout << seq[i] << " ";
    cout << endl;*/
    int len = 1, m = 1;
    for (int i = 1; i < seq.size(); ++i){
        if (seq[i] == seq[i - 1] + 1)
            len++;
        else{
            m = max(m, len);
            len = 1;
        }
    }
    m = max(m, len);
    return m;
}
int Query_count_sort(int l, int r){
    memset(cntsort, 0, sizeof(cntsort));
    for (int i = l; i <= r; ++i)
        cntsort[a[i]] = true;
    int len = 0, m = 0;
    for (int i = 1; i <= n; ++i){
        if (cntsort[i] == false){
            m = max(m, len);
            len = 0;
        }
        else len++;
    }
    m = max(m, len);
    return m;
}
bool is_in_range(int l, int r, int pos){
    return (l <= pos && pos <= r)? true: false;
}
int DFS_subtree_size(int ver){
    used[ver] = true;
    int subtreesz = 1;
    for (auto nb: v[ver])
        if (!used[nb])
            subtreesz += DFS_subtree_size(nb);
    return subtreesz;
}
int Query_DFS_subtree_size(int l, int r){
    for (int i = l; i <= r; ++i){
        if (is_in_range(l, r, posnum[a[i] + 1]))
            v[a[i]].push_back(a[i] + 1);
        if (is_in_range(l, r, posnum[a[i] - 1]))
            v[a[i]].push_back(a[i] - 1);
    }
    int m = 0, cur;
    for (int i = l; i <= r; ++i)
        if (!used[a[i]]){
            cur = DFS_subtree_size(a[i]);
            m = max(m, cur);
        }
    for (int i = l; i <= r; ++i){
        v[a[i]].clear();
        used[a[i]] = false;
    }
    return m;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> q;
    for (int i = 1; i <=n; ++i){
        cin >> a[i];
        posnum[a[i]] = i;
    }

    for (int i = 0; i < q; ++i){
        int l, r;
        cin >> l >> r;
        //cout << Query_stupid(l, r) << "\n";
        //cout << Query_count_sort(l, r) << "\n";
        cout << Query_DFS_subtree_size(l, r) << "\n";
    }
	return 0;
}
